$DIM ALL
'GDK.h
'-----

%HinterGrund    =0
%Schwarz        =0
%Grau           =10
%HellWeiss      =19

%DunkelRot      =20
%Rot            =30
%HellRot        =39

%DunkelGruen=40
%Gruen          =50
%HellGruen      =59

%DunkelBlau     =60
%Blau           =70
%HellBlau       =79

%DunkelLila     =80
%Lila           =90
%HellLila       =99

%DunkelBraun    =100
%Braun          =110
%HellBraun      =119

%DunkelGelb     =120
%Gelb           =130
%HellGelb       =139

%defstart       =140
%defend         =239

'Farbverlauf Schwarz->Grau->Weis->Grau->Schwarz
'----------------------------------------------
%SWSAnfang      =240
%SWSEnde        =254

%Weiss          =255
%VorderGrund    =255

'PCX Header
'----------
type PCXHeader
	DateiName       AS STRING * 64
	Kennung         AS BYTE
	Version         AS BYTE
	Komprimierung   AS BYTE
	BitPerPixel     AS BYTE
	xMin            AS WORD
	yMin            AS WORD
	xMax            AS WORD
	yMax            AS WORD
	hDPI            AS WORD
	vDPI            AS WORD
	RGBTAB          AS STRING * 48
	Reserved        AS BYTE
	Planes          AS BYTE
	ColorFlag       AS WORD
	Reserved2       AS STRING * 58
end type

dim PCXH as shared PCXHeader


'DIB Device Independet Bitmap
'-------------------------------
type BitmapFileHeader
	bfType          as  WORD
	bfSize          as DWORD
	bfReserved1     as  WORD
	bfReserved2     as  WORD
	bfOffBits       as DWORD
end type

type BitmapInfoHeader
	biSize          as DWORD
	biWidth         as DWORD
	biHeight        as DWORD
	biPlanes        as  WORD
	biBitCount      as  WORD
	biCompression   as DWORD
	biSizeImage     as DWORD
	biXPelsPerMeter as LONG
	biYPelsPerMeter as LONG
	biClrUsed       as DWORD
	biClrImportant  as DWORD
end type

dim BFH as shared BitmapFileHeader
dim BIH as shared BitmapInfoHeader

'VesaInit
'--------
type VesaInit
	Kennung     as string * 4
	VersionHi   as byte
	VersionLo   as byte
	HerOFF      as word
	HerSEG      as word
	reserved    as dword
	ModeOFF     as word
	ModeSEG     as word
	buffer      as string * 238
end type

dim VI as shared VesaInit
dim VISEG as shared word
dim VIOFF as shared word
VISEG=varseg(VI.Kennung)
VIOFF=varptr(VI.Kennung)

public VISEG,VIOFF

'VesaModeHeader
'--------------
type VesaModeHeader
	ModeFlag     as word
	Window1Flag  as byte
	Window2Flag  as byte
	WindowMoveKB as word
	WindowKB     as word
	Window1SEG   as word
	Window2SEG   as word
	CallMoveOFF  as word
	CallMoveSEG  as word
	BytePerScan  as word
	CharPerX     as word
	CharPerY     as word
	CharWidth    as byte
	CharHeight   as byte
	Planes       as byte
	BitPerPixel  as byte
	Blocks       as byte
	MemoryModel  as byte
	BlocksKB     as byte
	WindowMoveByte as DWORD
	IFMonitor    as integer
	IFOptional   as integer
	IFBIOSText   as integer
	IFColor      as integer
	IFGrafik     as integer
	IFW1         as integer
	IFW2         as integer
	IFW1Read     as integer
	IFW2Read     as integer
	IFW1Write    as integer
	IFW2Write    as integer
	X            as integer
	Y            as integer
	dummy as string *230
end type

dim VMH as shared VesaModeHeader
dim VMHSEG as shared word
dim VMHOFF as shared word
VMHSEG=varseg(VMH.ModeFlag)
VMHOFF=varptr(VMH.ModeFlag)


DIM VMode(30)   AS SHARED WORD
DIM MemModel(5) AS SHARED STRING

public VMode(),MemModel$(),VMHSEG,VMHOFF

VESAMEMMODEL:
data "wie im gewhnlichem Textmodus."
data "wie im CGA Format also 2 oder 4 Speicherblcke."
data "wie im Hercules Format mit 4 Speicherblcken."
data "wie im EGA und dem VGA Modus mit 16 Farben."
data "gepacktes Format mit 2 Punkten in einem Byte."
data "normales VGA Format also 1 Byte pro Punkt."

restore VESAMEMMODEL
dim i as integer
for i=0 to 5
	Read MemModel$(i)
next

TYPE RGBQUAD
	rgbRed      as BYTE
	rgbGreen    as BYTE
	rgbBlue     as BYTE
END TYPE

DIM RGB(255)    AS SHARED RGBQUAD
DIM rgbSEG      AS SHARED WORD
DIM rgbOFF      AS SHARED WORD

rgbSEG=varseg(RGB(0).rgbRed)
rgbOFF=varptr(RGB(0).rgbRed)

type WAVHeader
	mainChunk   as STRING * 4
	mainLenght  as DWORD
	Typ         as STRING * 4

	subChunk    as STRING * 4
	subLenght   as DWORD
	Format      as WORD
	Modus       as WORD
	SmpFrq      as DWORD
	BytePerSec  as DWORD
	BytePerSmp  as WORD
	BitPerSmp   as WORD

	dataChunk   as STRING * 4
	dataLenght  as DWORD

	Start       as DWORD
	Ende        as DWORD
end type

dim WAVH as shared WAVHeader

'#################
'# ------------- #
'#  VGA Section  #
'# ------------- #
'#################

declare sub SetCRTOffset(BYVAL zOFF as byte) 
declare sub SetVerticalPelPaning(BYVAL zOFF as byte) 
declare sub SetHorizontalPelPaning(BYVAL zOFF as byte) 
declare sub Sync()

'#######################
'# ------------------- #
'#  Interrupt Section  #
'# ------------------- #
'#######################

declare sub GetIRQVector(byval IRQnr as integer,zSEG as word,zOFF as word) 
declare sub SetIRQVector(byval IRQnr as integer,byval zSEG as word,byval zOFF as word) 

'###################
'# --------------- #
'#  Datei Section  #
'# --------------- #
'###################
declare function ReadDWORD (byval dn as integer)  AS DWORD
declare sub 	 WriteDWORD (byval dn as integer,byval dw as dword) 
declare function ReadWORD (byval dn as integer)  AS WORD
declare sub 	 WriteWORD (byval dn as integer,byval w as word) 
declare function ReadBYTE(byval dn as integer)  as byte
declare sub 	 WriteByte (byval dn as integer,byval b as byte) 

'###############
'#-------------#
'# PCX-SECTION #
'#-------------#
'###############
declare function ifPCX(byval dname as string,ErrorFlag as integer)  as integer
declare function GetPCXHeader ( byval dname as string,ErrorFlag as integer)  AS INTEGER
declare sub 	 ShowPCXHeader() 
declare sub 	 LoadPCX(byval dname as string,_
			byval zSEG as word,_
			byval zOFF as word,_
			byval qStart as integer,_
			byval zStart as integer,_
			byval zAnz as integer) 
declare sub LoadPCXColorPal(byval dname as string) 

'##################
'# -------------- #
'#  WAVE Section  #
'# -------------- #
'##################
declare function ifWAV(	BYVAL dname as string,_
				ErrorFlag as integer)  AS INTEGER

declare function GetWAVHeader(	byval dname as string,_
						ErrorFlag as integer)  AS INTEGER
declare sub ShowWAVHeader()
declare sub LoadWAV(byval dname as string,_
			byval zSEG as word,_
            byval zOFF as word) 

'####################
'# ---------------- #
'#  Bitmap Section  #
'# ---------------- #
'####################
declare function ifDIB(	BYVAL dname as string,_
				ErrorFlag as integer)  AS INTEGER

declare function GetDIBHeader(	BYVAL dname as string,_
						ErrorFlag as integer)  AS INTEGER
declare sub ShowDIBHeader() 
declare sub LoadDIB (	byval dname as string,_
				byval zSEG as word,_
                byval zOFF as word,_
                byval qstart as integer,_
                byval zstart as integer,_
                byval zAnz as integer) 

declare sub LoadDIBColorPAL (	byval dname as string) 

'##########################
'# ---------------------- #
'#  Soundblaster Section  #
'# ---------------------- #
'##########################

declare sub PlayDSP(byval DspAdr as word,byval DSPIRQ as word,byval qSEG as word,byval qOFF as word,byval qLEN as word,byval qSPEED as word) 
declare function IFDspBusy()  as INTEGER
declare function ResetDSP(byval DSPAdr AS WORD)  AS INTEGER
declare function GetDSPAdr(DspAdr AS WORD)  AS INTEGER
declare function GetDSPIRQ(byval SBAdr AS WORD,SBIRQ AS WORD)  AS INTEGER
declare function SoundCard(sbadr AS WORD,sbirq AS WORD,ErrorFlag AS INTEGER)  AS INTEGER

'##################
'# -------------- #
'#  VESA Section  #
'# -------------- #
'##################
declare function CSTRfromRAM(byval qSEG as word,byval qOFF as word)  AS STRING
declare function ifVESA()  AS INTEGER
declare function GetVesaModeCount(VMode() as word)  AS INTEGER
declare function GetVesaModeHeader(	byval modeNr as word)  AS INTEGER
declare sub ShowVesaModeHeader()
declare function GetVesaModeNumberInArray(	byval x as integer,_
											byval y as integer,_
                                    		byval BitPerPixel as integer,_
                                    		byval anz as integer)  AS INTEGER

declare function GetVesaMode()  AS INTEGER
declare sub MoveVesaWindow(byval Page as integer,byval WindowNr as integer)
declare sub SetVesaFastCall(byval zSEG as word,byval zOFF as word) 
declare sub SetVesaMode(byval modeNr as word) 
declare sub MoveVesaFast(byval Page as integer,byval WindowNr as integer) 
declare sub SetVesaPixel8(	byval x   as integer,_
					byval y   as integer,_
                    byval col as byte) 
declare sub FillVesaPoly8(	xp()      as integer,_
					yp()      as integer,_
                    byval ea  as integer,_
                    byval col as byte) 
declare sub LoadVESAPCX(byval dname as string) 
declare sub SetVesaPixel15( byval x as integer,_
					byval y as integer,_
                    byval r as byte,_
                    byval g as byte,_
                    byval b as byte) 
declare sub VesaCopy8(  byval xq as integer,_
				byval yq as integer,_
                byval xz as integer,_
                byval yz as integer,_
                byval b  as integer,_
                byval h  as integer) 
declare sub VesaMaskCopy8(	byval xq  as integer,_
					byval yq  as integer,_
                    byval xz  as integer,_
                    byval yz  as integer,_
                    byval b   as integer,_
                    byval h   as integer,_
                    byval col as byte)
declare sub VesaCopy15( byval xq as integer,_
				byval yq as integer,_
                byval xz as integer,_
                byval yz as integer,_
                byval b  as integer,_
                byval h  as integer)

'####################
'# ---------------- #
'#  Grafik Section  #
'# ---------------- #
'####################
declare sub gSetVideoMode (BYVAL mode AS BYTE)
declare function gGetVideoMode()  AS BYTE
declare sub gSetColor(byval palnr AS BYTE,byval red AS BYTE,byval green AS BYTE,byval blue AS BYTE)
declare sub gSetColorPal()
declare sub gSetRamColorPal(byval qSEG AS WORD,byval qOFF AS WORD,byval Start AS INTEGER,byval cAnz AS INTEGER)
declare sub gLoadColorPal(	byval dname AS STRING)
declare sub gFill(byval zSEG as word,byval zOFF as word,byval anz as word,byval col1 as byte,byval col2 as byte)
declare sub gSetPixel (byval zSEG as word,byval zOFF as word,byval x as word,byval y as word,byval col as byte)
declare function gGetPixel (byval qSEG as word,byval qOFF as word,byval x as word,byval y as word)  AS BYTE
declare sub gLine(byval ramSEG as word,byval ramOFF as word,byval x1 as integer,byval y1 as integer,byval x2 as integer,byval y2 as integer,byval col as byte)
declare sub gCopyUp(byval qSEG as word,byval qOFF as word,byval zSEG as word,byval zOFF as word,byval xq as integer,byval yq as integer,byval xz as integer,byval yz as integer,byval b as integer,byval h as integer)
declare sub gCopyDouwn(byval qSEG as word,byval qOFF as word,byval zSEG as word,byval zOFF as word,byval xq as integer,byval yq as integer,byval xz as integer,byval yz as integer,byval b as integer,byval h as integer)
declare sub gXcopy(byval qSEG as word,byval qOFF as word,byval zSEG as word,byval zOFF as word,byval xq as integer,byval yq as integer, byval xz as integer,byval yz as integer,byval xbreite as integer,byval ybreite as integer)
declare sub gMaskCopy(byval qseg as word,byval qoff as word,byval zseg as word,byval zoff as word,byval qx as integer,byval qy as integer,byval zx as integer,byval zy as integer,byval b as integer,byval h as integer,byval maske as byte)

declare sub gFadeOut(	byval zSEG as word,byval zOFF as word,_
						byval x as integer,byval y as integer,_
                        byval b as integer,byval h as integer,_
                        byval anf as byte,byval ende as byte)

declare sub gFadeIN(byval zSEG as word,byval zOFF as word,byval x as integer,byval y as integer,byval b as integer,byval h as integer,byval anf as byte,byval ende as byte)
declare sub gColorRectangle(byval zSEG as word,byval zOFF as word,byval x1 as integer,byval y1 as integer,byval x2 as integer,byval y2 as integer,byval c1 as integer,byval c2 as integer,byval c3 as integer,byval c4 as integer) 
declare sub gPrint(	byval tSEG as word,byval tOFF as word,_
			byval zSEG as word,byval zOFF as word,_
            byval x as integer,byval y as integer,_
            byval Text as string,_
            byval tx as integer,byval ty as integer,_
            byval zanz as integer)

declare sub gPrintFast(	byval tSEG as word,byval tOFF as word,_
						byval zSEG as word,byval zOFF as word,_
                        byval x as integer,byval y as integer,_
                        byval Text as string,_
                        byval tx as integer,byval ty as integer,_
                        byval dx as integer,byval dy as integer,_
                        byval zanz as integer)

declare sub gLineRectangle(byval RamSeg as word,RamOff as word,byval x1 as integer,byval y1 as integer,byval x2 as integer,byval y2 as integer,byval col as byte)

declare sub gFillPoly(byval zSEG as word,byval zOFF as word,xp() as integer,yp() as integer,byval ea as integer,byval col as byte)

declare sub gFillColorPoly(	byval zSEG as word,byval zOFF as word,_
					xp() as integer,yp() as integer,_
                    byval ea as integer,cp() as integer)

declare sub gPaintTexture (byval QSEG as word,byval QOFF as word,byval ZSEG as word,byval ZOFF as word,byval xa as integer,byval ya as integer,byval pb as integer,byval lh as integer,byval rh as integer,byval texb as integer,byval texh as integer)

declare sub gMaskPaintTexture (	byval qSEG as word,_
								byval qOFF as word,_
                        		byval zSEG as word,_
                        		byval zOFF as word,_
                        		byval xa as integer,_
                        		byval ya as integer,_
                        		byval pb as integer,_
                        		byval lh as integer,_
                        		byval rh as integer,_
                        		byval texb as integer,_
                        		byval texh as integer)


declare sub gFillSolidPoly(	byval zSEG as word,_
							byval zOFF as word,_
							xp() as integer,_
                    		yp() as integer,_
                    		byval ea as integer,_
                    		byval cc as integer)



declare sub gFillTexturePoly(	byval zSEG as word,_	'Segment auf Ausgabespeicher
						byval zOFF as word,_    'Offset
						xp() as integer,_       'Arrays mit
                        yp() as integer,_		'den Polygonkoordinaten
                        byval ea as integer,_   'Anzahl der Eckpunkte
                        byval yanz as word,_    'Maximale Anzahl der Y-Zeilen
                        byval qSEG as word,_    'Segment auf Texturespeicher
                        byval qOFF as word,_    'Offset
                        txp() as integer,_      'Arrays mit
                        typ() as integer)  'den Texturekoordinaten


declare function gGetOFF(	byval nr as integer,_
							byval tx as integer,_
                            byval ty as integer)  AS WORD

declare sub gNewSpot(	byval zSEG as word,byval zOFF as word,_
						byval x as integer,byval y as integer,_
                        byval col as byte)

declare sub gImpCopy(	byval qseg as word,byval qoff as word,_
						byval zseg as word,byval zoff as word,_
                		byval qx as integer,byval qy as integer,_
                		byval zx as integer,byval zy as integer,_
                		byval b as integer,byval h as integer)

declare function gFade(	byval qSEG as word,byval qOFF as word,_
						byval zSEG as word,byval zOFF as word,_
                        byval qx as integer,byval qy as integer,_
                        byval zx as integer,byval zy as integer,_
                        byval b as integer,byval h as integer)  AS INTEGER

$include        "gdk.inc"


