'#################
'# ------------- #
'#  VGA Section  #
'# ------------- #
'#################

SUB SetCRTOffset(BYVAL zOFF as byte) public
	!mov DX,&H3D4
    !mov AH,zOFF?       ;AH=HIGH Byte des Offsets
    !mov AL,&H13        ;Offset Register
    !out DX,AX
END SUB

SUB SetVerticalPelPaning(BYVAL zOFF as byte) public
    !mov DX,&H3D4
    !mov AH,zOFF?       ;Bit 0-5 (0-31)
    !and AH,&H1F
    !mov AL,&H08        ;Vertical Pel Paning Register
    !out DX,AX

END SUB

SUB SetHorizontalPelPaning(BYVAL zOFF as byte) public
    !mov DX,&H3C0   ;Attribute Controller Schreiben
    !mov AL,&H33    ;Register &13 + &20 und Bitb 5
    !out DX,AL
    !mov AL,zOFF?
    !and AL,&h0F
    !out DX,AL
END SUB

SUB Sync
	!mov 		dx,&H3DA               	; CRT-Controller
vbi1:
	!in 		al,dx
	!test 		al,&B00001000
	!jnz 	vbi1     	              	; Schon gestartet
vbi2:
	!in 		al,dx                   ; Auf neuen Interwall warten
	!test 		al,&B00001000
	!jz 	vbi2
end sub


'#######################
'# ------------------- #
'#  Interrupt Section  #
'# ------------------- #
'#######################

SUB GetIRQVector(byval IRQnr as integer,zSEG as word,zOFF as word) public
    dim tempSEG as local word
    dim tempOFF as local word

    !push   DS
	!push   BX
	!push   ES
	!push   AX

	!mov    AX,&h0000       ;Segment 0 Interrupttabelle
	!mov    ES,AX


	!mov    BX,IRQnr%       ;Interrupt-Nummer
	!shl    BX,1            ;Interrupt Nr. * 4
	!shl    BX,1
	!cmp    BX,&h20         ;Interrupt >=8 (4*8=&h20)
	!jnc    VT2             ;Wert fr Tabelle 2 berechnen

	!add    BX,&H20         ;Offset Tabelle 1 adieren

	!jmp near OFFHolen
VT2:
	!add    BX,&H1a0        ;Offset Tabelle 2 adieren

OFFHolen:
	!mov    AX,ES:[BX]      ;Offset der IRQ-Routine holen
	!mov    tempOFF??,AX    ;und temporare merken
	!mov    AX,ES:[BX+2]    ;Segment der IRQ-Routine
	!mov    tempSEG??,AX    ;und temporare merken

	!pop    AX
	!pop    ES
	!pop    BX
	!pop    DS

	zSEG??=tempSEG??
    zOFF??=tempOFF??

END SUB


SUB SetIRQVector(byval IRQnr as integer,byval zSEG as word,byval zOFF as word) public
		!CLI
		!push   BX
		!push   ES

		!mov    AX,&h0000   ;Segment 0 Interrupttabelle
		!mov    ES,AX


		!mov    BX,IRQnr%   ;Interrupt-Nummer
		!shl    BX,1        ;Interrupt Nr. * 4
		!shl    BX,1
        !cmp    BX,&h20     ;Interrupt >=8 (4*8=&h20)
		!jnc    VTT2        ;Wert fr Tabelle 2 berechnen

		!add    BX,&H20     ;Offset Tabelle 1 adieren

		!jmp near OFFSetzen
VTT2:
		!add    BX,&H1a0    ;Offset Tabelle 2 adieren

OFFSetzen:
		!mov    AX,zOFF??
		!mov    ES:[BX],AX  ;Offset der IRQ-Routine setzen
		!mov    AX,zSEG??
		!mov    ES:[BX+2],AX ;Segment der IRQ-Routine setzen

		!pop    ES
		!pop    BX
		!STI

END SUB

'###################
'# --------------- #
'#  Datei Section  #
'# --------------- #
'###################
'-----------------------------------------------------------------------
'Datei Lese- u. Schreib- Funktionen fr binare geffnete *.WAV u. *.BMP|
'Dateien dn ist die Filehandle der zuvor geffnetten Binaredatei.      |
'-----------------------------------------------------------------------

'-----------------------------------------------------------------------------
'Liest und schreibt ein Doppelword loword-hiword u. konv. es ins Intelformat.|
'-----------------------------------------------------------------------------
FUNCTION ReadDWORD (byval dn as integer) public AS DWORD
    dim lo 		as local byte
    dim hi 		as local byte
    dim los 	as local string
    dim his 	as local string
    dim loword 	as local word
    dim hiword 	as local word

	GET$ #dn,1,los$:lo?=asc(los$)
    GET$ #dn,1,his$:hi?=asc(his$)
    loword??=hi?*256+lo?

	GET$ #dn,1,los$:lo?=asc(los$)
    GET$ #dn,1,his$:hi?=asc(his$)

    hiword??=hi?*256+lo?

    ReadDWORD???=hiword??*65536+loword??

END FUNCTION

SUB WriteDWORD (byval dn as integer,byval dw as dword) public
    dim hiword 	as local dword
    dim loword 	as local dword
    dim lo 		as local byte
    dim hi 		as local byte
    dim los 	as local string
    dim his 	as local string

	hiword???=dw???/65536
    loword???=dw???-hiword???*65536

    hi?=int(loword???/256)
    lo?=int(loword??? MOD 256)
    los$=chr$(lo?):his$=chr$(hi?)

    PUT$ #dn%,los$
    PUT$ #dn%,his$

    hi?=int(hiword???/256)
    lo?=int(hiword??? MOD 256)
    los$=chr$(lo?):his$=chr$(hi?)

    PUT$ #dn%,los$
    PUT$ #dn%,his$

END SUB

'----------------------------------------------------------------------
'Liest und schreibt ein Word lo-hi und konvertiert es ins Intelformat.|
'----------------------------------------------------------------------
FUNCTION ReadWORD (byval dn as integer) public AS WORD
    dim lo 	as local byte
    dim hi 	as local byte
    dim los as local string
    dim his as local string

    GET$ #dn%,1,los$:lo?=asc(los$)

    GET$ #dn%,1,his$:hi?=asc(his$)

    ReadWORD??=lo?+hi?*256

END FUNCTION

SUB WriteWORD (byval dn as integer,byval w as word) public
    dim lo as local byte
    dim hi as local byte
    dim los as local string
    dim his as local string

	hi?=int(w??/256):his$=chr$(hi?)
    lo?=w??-(hi?*256):los$=chr$(lo?)

    PUT$ #dn%,los$
    PUT$ #dn%,his$

END SUB

'------------------------------------------------
'Liest und schreibt ein Byte und konvertiert es.|
'------------------------------------------------
FUNCTION ReadBYTE(byval dn as integer) public as byte
    dim lo as local byte
    dim los as local string

    local los$,lo?

	GET$ #dn%,1,los$:lo?=asc(los$)

    ReadBYTE?=lo?

END FUNCTION

SUB WriteByte (byval dn as integer,byval b as byte) public
    dim lo as local string
    local lo$

	lo$=chr$(b?)

	PUT$ #dn%,lo$

END SUB

'###############
'#-------------#
'# PCX-SECTION #
'#-------------#
'###############

function ifPCX(byval dname as string,ErrorFlag as integer) public as integer

	dim dn as local integer
	dim kennung as local byte
	dim ErrorCode as integer

	dn%=FreeFile

	ON ERROR RESUME NEXT
	OPEN dname$ FOR INPUT AS dn%

	IF ERR=53 then
		ErrorFlag%=1
		close dn%
	else
		close dn%
		dn%=FreeFile
		OPEN dname$ FOR BINARY AS dn%
		Kennung?=ReadByte?(dn%)
		IF Kennung? <>&h0a THEN ErrorCode%=2
		close dn%
	END IF

	if ErrorCode% then
		ErrorFlag%=ErrorCode%
		ifPCX%=0
	else
		ifPCX%=&HFFFF
	end if

end function


FUNCTION GetPCXHeader ( byval dname as string,ErrorFlag as integer) public AS INTEGER

	dim dn          as local integer
	dim ErrorCode   as local integer

	dn%=FreeFile

	ON ERROR RESUME NEXT
	open dname$ for INPUT as dn%

	IF ERR=53 then
		ErrorCode%=1
		close dn%
	else
		dn%=FreeFile
		open dname$ for binary as dn%
		PCXH.Kennung =ReadByte?(dn%)
		IF PCXH.Kennung <>&h0a THEN
			ErrorCode%=2
			close dn%
		else
			PCXH.DateiName$     =dname$
			PCXH.Version       =ReadByte?(dn%)
			PCXH.Komprimierung =ReadByte?(dn%)
			PCXH.BitPerPixel   =ReadByte?(dn%)

			IF PCXH.BitPerPixel<>&h08 THEN
				ErrorCode%=3
				close dn%
			else
				PCXH.xMin       =ReadWORD(dn%)
				PCXH.yMin       =ReadWORD(dn%)
				PCXH.xMax       =ReadWORD(dn%)
				PCXH.yMax       =ReadWORD(dn%)
				close dn%
			END IF
		END IF
	END IF


	IF ErrorCode% THEN
		GetPCXHeader%=0
		ErrorFlag%=ErrorCode%
	else
		GetPCXHeader%=&HFFFF
	END IF

END FUNCTION

SUB ShowPCXHeader() public

	dim text as local string

	text$="Name		:"+extract$(PCXH.DateiName$," ")+chr$(10)
	text$=text$+"Kennung		:"+str$(PCXH.Kennung)+chr$(10)
	text$=text$+"Version		:"+str$(PCXH.Version)+chr$(10)
	text$=text$+"Kompriemierung	:"+str$(PCXH.Komprimierung)+chr$(10)
	text$=text$+"BitProPixel	:"+str$(PCXH.BitPerPixel)+chr$(10)
	text$=text$+"xMIN		:"+str$(PCXH.xMIN)+chr$(10)
	text$=text$+"yMIN		:"+str$(PCXH.yMIN)+chr$(10)
	text$=text$+"xMAX		:"+str$(PCXH.xMAX)+chr$(10)
	text$=text$+"yMAX		:"+str$(PCXH.yMAX)+chr$(10)
	print text$


END SUB

SUB LoadPCX(byval dname as string,_
			byval zSEG as word,_
			byval zOFF as word,_
			byval qStart as integer,_
			byval zStart as integer,_
			byval zAnz as integer) public

	dim zeile(320)  as local byte
	dim ZeileSEG    as local word
	dim ZeileOFF    as local word
	dim xb          as local integer
	dim yh          as local integer
	dim dn          as local integer
	dim x           as local integer
	dim y           as local integer
	dim wert        as local integer
	dim Zaehler     as local integer
	dim z           as local integer

	IF PCXH.BitPerPixel<>&h08 THEN EXIT SUB
	xb%=PCXH.xMAX-PCXH.xMIN
	IF xb%<319 THEN EXIT SUB
	yh%=PCXH.yMAX-PCXH.yMIN


	ZeileSEG??=varseg(zeile?(0))
	ZeileOff??=varptr(zeile?(0))

	dn%=FreeFile
	print "load "+dname$+" in memory"
	print "{";
	OPEN dname$ FOR BINARY AS dn%

	'Komprimierte Datei
	IF PCXH.Komprimierung THEN

		'Datenzeiger auf Pixeldaten setzen
		Seek dn%,128

		'Zeilenzhler init
		y%=0

		'Maximal so viele Zeilen einlesen wie in zAnz bergeben.
		'Jedoch nicht mehr als in der Datei vorhanden
		'-------------------------------------------------------
		IF yh%<(qStart%+zAnz%) then zAnz%=yh%-qStart%

		While y%<(qStart%+zAnz%+1)
			'Spaltenzhler init
			x%=0

			'Maximal PCXH.xMIN+1 Pixel in eine Zeilen einlesen.
			'--------------------------------------------------
			While x%<(xb%+1)
			'Wenn Bit 6 und 7 gesetzt dann RLE Tupel
			wert%=ReadByte?(dn%)
			if wert%>=&hc0 then
				'Anzahl Bit 0 - 5
				zaehler%=wert% and &h3F
				wert%=ReadByte?(dn%)
				if zaehler%=1 then
					Zeile?(x%)=wert%
					incr x%
				else
					for z%=0 to zaehler%-1
						Zeile?(x%)=wert%
						incr x%
					next
				end if
			else
				Zeile?(x%)=wert
				incr x%
			end if

		WEND
		if y%>=qStart% then gCopyUP ZeileSEG??,ZeileOFF??,zSEG??,zOFF??,0,0, 0,zStart%+(y%-qStart%),xb+1,1
		incr y%
		print ".";
		WEND

	else
	   'Datenzeiger auf Pixeldaten setzen
		Seek dn%,128

		'Zeilenzhler init
		y%=0

		'Maximal so viele Zeilen einlesen wie in zAnz bergeben.
		'Jedoch nicht mehr als in der Datei vorhanden
		'-------------------------------------------------------
		IF yh%<(qStart%+zAnz%) then zAnz%=yh%-qStart%

		While y%<(qStart%+zAnz%+1)
		'Spaltenzhler init
			x%=0

		'Maximal 320 Pixel in eine Zeilen einlesen.
		'------------------------------------------
		While x%<(xb%+1)
			Zeile?(x%)=ReadByte?(dn%)
			incr x%

		WEND
		if y%>=qStart% then gCopyUp ZeileSEG??,ZeileOFF??,zSEG??,zOFF??,0,0, 0,zStart%+(y%-qStart%),xb%,1

		incr y%
		print ".";
		WEND
	END IF
	close dn%
	print "}"
END SUB

SUB LoadPCXColorPal(byval dname as string) public

	dim dn  as local integer
	dim i   as local integer
	dim r   as local byte
	dim g   as local byte
	dim b   as local byte
	dim l   as local long

	IF PCXH.Kennung<>&h0A THEN EXIT SUB
	IF PCXH.Version<>&h05 THEN EXIT SUB

	dn%=FreeFile
	ON ERROR RESUME NEXT
	OPEN dname$ FOR INPUT AS dn%
	IF ERR=53 THEN
		close dn%
	else
		l&=lof(dn%)
		close dn%
		dn%=FreeFile
		OPEN dname$ FOR BINARY AS dn%
		Seek dn%,l&-768

		def seg=rgbSEG??

		for i%=0 to 255
			R?=ReadByte(dn%)
			shift right R?,2
			poke rgbOFF??+i%*3+0,R?

			G?=ReadByte(dn%)
			shift right G?,2
			poke rgbOFF??+i%*3+1,G?

			B?=ReadByte(dn%)
			shift right B?,2
			poke rgbOFF??+i%*3+2,B?
		next
		def seg
		close dn%
	END IF
END SUB

'##################
'# -------------- #
'#  WAVE Section  #
'# -------------- #
'##################

'Ist es eine WaveDatei dann ist der Rckgabewert <> 0 (TRUE)
'-----------------------------------------------------------
function ifWAV(	BYVAL dname as string,_
				ErrorFlag as integer) public AS INTEGER

    dim dn 			as local integer
    dim ErrorCode 	as local integer

    dn%=FreeFile
    ON ERROR RESUME NEXT
    OPEN dname$ FOR INPUT AS dn%
    IF ERR=53 THEN

		ErrorCode%=1
        close dn%
    else

		close dn%
		dn%=FreeFile
		OPEN dname$ FOR BINARY AS #dn%

		'Den mainchunk einlesesen
		GET$ #dn%,4,WAVH.mainchunk

		'Wenn kein gltiges RIFF Format dann mit Fehlerwert abbrechen.
		IF WAVH.mainchunk <>"RIFF" then
			ErrorCode%=2
		END IF
		close dn%
    END IF

    IF ErrorCode% THEN
        ErrorFlag%=ErrorCode%
		IFWAV%=0
    ELSE
		IFWAV%=&hFFFF
    END IF

END FUNCTION

'---------------------------------------------------------------------------
'Fllt die drei Datenstrukturen mit Daten einer WAV Datei.Der Funktion mu |
'im STRING dmame$ der Pfad und Dateinamen bergeben werden.                        |
'Bei einem Fehler ist der Rckgabewert >0 u. ErrorFlag% entspricht dem     |
'ErrorCode.                                                                                                                                |
'---------------------------------------------------------------------------
FUNCTION GetWAVHeader(	byval dname as string,_
						ErrorFlag as integer) public AS INTEGER

    dim dn 			as local integer
    dim ErrorCode 	as local integer
    dim LeseVersuch as local integer

    dn%=FreeFile
    ON ERROR RESUME NEXT
    OPEN dname$ FOR INPUT AS dn%
    IF ERR=53 THEN
		ErrorCode%=1
		close dn%
    else
		close dn%
		dn%=FreeFile
		OPEN dname$ FOR BINARY AS dn%

		'Den mainchunk einlesesen
		'------------------------
		GET$ #dn%,4,WAVH.mainchunk

		'Wenn kein gltiges RIFF Format dann mit Fehlerwert abbrechen.
		'-------------------------------------------------------------
		IF WAVH.mainchunk <>"RIFF" THEN
			ErrorCode%=1
	    	close dn%
		else
			'Anzahl der Bytes ab hier bis zum Dateiende.
			'-------------------------------------------
			WAVH.mainlenght=ReadDWORD(dn%)

			'Wenn keine WAVE-Datei dann mit Fehlerwert abbrechen.
			'----------------------------------------------------
			GET$ #dn%,4,WAVH.typ
			IF WAVH.typ <>"WAVE" then
				ErrorCode%=2
				close dn%
	    	else
	    		SUBCHUNK:
				'Versuchen den subchunk "fmt " zu lesen.
				'---------------------------------------
				GET$ #dn%,4,WAVH.subchunk

				'Wenn kein RIFF subchunk dann andere Chunktypen berlesen.
				'---------------------------------------------------------
				If WAVH.subchunk <> "fmt " and Leseversuch%<100 then
					seek #dn%,(seek(dn)-5)
					incr Leseversuch%
					goto SUBCHUNK
				end if

				IF WAVH.subchunk <> "fmt " then
					ErrorCode%=3
		    		close dn%
				else
					Leseversuch%=0

					'Ab hier den kompletten Wavesubchunk einlesen.
					'---------------------------------------------
					WAVH.sublenght     = ReadDWORD(dn%)

					WAVH.format     = ReadWORD (dn%)
					WAVH.modus      = ReadWORD (dn%)
					WAVH.smpfrq     = ReadDWORD(dn%)
					WAVH.bytepersec = ReadDWORD(dn%)

					WAVH.bytepersmp = ReadWORD (dn%)
					WAVH.bitpersmp  = ReadWORD (dn%)
		    		IF (WAVH.modus <> &h01) or (WAVH.bitpersmp<>&h08) THEN
						ErrorCode%=4
		    		else
						rDATACHUNK:
						'Versuchen den Datachunk zu lesen.
						'---------------------------------
						GET$ #dn%,4,WAVH.datachunk

						'Wenn kein RIFF datachunk dann andere Chunktypen berlesen.
						'---------------------------------------------------------
						IF WAVH.datachunk <> "data" and Leseversuch<100 then
							seek #dn,(seek(dn%)-5)
							incr Leseversuch
							goto rDATACHUNK
						end if

						IF WAVH.datachunk <> "data" then
							ErrorCode%=5
							close dn%
						else
							'Anzahl der Bytes des Datachunks mit den eigentlichen Sampledaten lesen.
							'-----------------------------------------------------------------------
							WAVH.datalenght    =ReadDWORD(dn%)-2

							'Optionel die Start- u. Endposition der Daten innerhalb der Datei merken.
							'------------------------------------------------------------------------
							WAVH.start = LOC(dn%)+1
							WAVH.ende  = WAVH.start + WAVH.datalenght
							close dn%
						END IF  'data
					END IF 'modus oder BitPerSmp Error
				END IF 'fmt
			END IF 'WAVE
		END IF 'RIFF
    END IF 'Datei

	IF ErrorCode% THEN
		GetWAVHeader%=0
		ErrorFlag%= ErrorCode%
    else
		GetWAVHeader%=&HFFFF
    END IF

END FUNCTION

'------------------------------------------------------------------
'Message mit allen Informationen zur aktuellen WAV-Datei anzeigen.
'------------------------------------------------------------------
SUB ShowWAVHeader public
     dim info 	as local string
     dim kanal 	as local string

     Info$="MAINCHUNK"+chr$(10)
     Info$=Info$+"Chunkkennung	: "+WAVH.mainchunk+chr$(10)
     Info$=Info$+"Dateilnge	:"+str$(WAVH.mainlenght+8)+chr$(10)
     Info$=Info$+"Dateitype 	: "+WAVH.typ+chr$(10)
     Info$=Info$+chr$(10)
     Info$=Info$+"SUBCHUNK"+chr$(10)
     Info$=Info$+"Chunkkennung 	: "+WAVH.subchunk+chr$(10)
     Info$=Info$+"Chunklnge	:"+str$(WAVH.sublenght)+chr$(10)
     Info$=Info$+"Format 1=PCM	:"+str$(WAVH.format)+chr$(10)
     if WAVH.modus=1 then kanal$="MONO" else kanal$="STEREO"
     Info$=Info$+"Modus     	: "+kanal$+chr$(10)
     Info$=Info$+"Smp.Frequenz	:"+str$(WAVH.smpfrq)+chr$(10)
     Info$=Info$+"Bytes pro Sek	:"+str$(WAVH.bytepersec)+chr$(10)
     Info$=Info$+"Bytes pro Smp	:"+str$(WAVH.bytepersmp)+chr$(10)
     Info$=Info$+"Bits  pro Smp	:"+str$(WAVH.bitpersmp)+chr$(10)
     Info$=Info$+chr$(10)
     Info$=Info$+"DATACHUNK"+chr$(10)
     Info$=Info$+"Chunkkennung 	: "+WAVH.datachunk+chr$(10)
     Info$=Info$+"SmpByteanzahl	:"+str$(WAVH.datalenght)+chr$(10)
     Info$=Info$+"Optional !"+chr$(10)
     Info$=Info$+"Datenbeginn	:"+str$(WAVH.start)+chr$(10)
     Info$=Info$+"Datenende   	:"+str$(WAVH.ende)
     print Info$

END SUB

SUB LoadWAV(byval dname as string,_
			byval zSEG as word,_
            byval zOFF as word) public

	dim block 	as local integer
    dim temp 	as local string
    dim dn		as local integer
    dim rest	as local word
    dim anz		as local word
    dim i		as local word

    block%=1024
    temp$=space$(block%)
    dn%=FreeFile
    ON ERROR RESUME NEXT
    OPEN dname$ FOR INPUT AS dn%
    IF ERR=53 THEN
		close dn%
		EXIT SUB
    else
		close dn%
		DEF SEG=zSEG??

		dn%=FreeFile
		OPEN dname$ FOR BINARY AS dn%
		Seek dn%,WAVH.start
		rest??=WAVH.datalenght mod block%
		anz??=WAVH.datalenght\block%

		For i??=0 to anz??-1

	    	GET$ dn,block,temp$
			poke$ zOFF??,temp$
	    	incr zOFF??,block%
		next

		IF rest?? THEN

			for i??=0 to rest??-2
            	poke zOFF??,ReadBYTE(dn%)
				incr zOFF??
			next
		END IF

		DEF SEG
		close dn%
    END IF
END SUB

'####################
'# ---------------- #
'#  Bitmap Section  #
'# ---------------- #
'####################

FUNCTION ifDIB(	BYVAL dname as string,_
				ErrorFlag as integer) public AS INTEGER

	dim dn 			as local integer
    dim ErrorCode 	as local integer


    dn%=FreeFile
    ON ERROR RESUME NEXT
    OPEN dname$ FOR INPUT AS dn%
    IF ERR=53 then
		ErrorCode%=1
		close dn%
    else
		close dn%
		dn%=FreeFile
		OPEN dname$ FOR BINARY AS dn%

		'Versuchen den BitMapFileHeader zu lesen.
		'----------------------------------------
		BFH.bfType =ReadWORD(dn%)

		'Wenn ungltiges BMP Format dann mit Fehlerwert abbrechen.
		'---------------------------------------------------------
		IF BFH.bfType <>&H4D42 then ErrorCode%=2
		close dn%
	END IF

    IF ErrorCode% Then
		IFDIB%=0
		ErrorFlag%=ErrorCode%
    else
		IFDIB%=&hFFFF
    END IF
END FUNCTION

FUNCTION GetDIBHeader(	BYVAL dname as string,_
						ErrorFlag as integer) public AS INTEGER

    dim dn as local integer
    dim ErrorCode as local integer

    dn%=FreeFile
    ON ERROR RESUME NEXT
    OPEN dname$ FOR INPUT AS dn%
    IF ERR=53 then
		ErrorCode%=1
		close dn%
    else
		close dn%
		dn%=FreeFile
		OPEN dname$ FOR BINARY AS dn

		'Versuchen den BitMapFileHeader zu lesen.
		'----------------------------------------
		BFH.bfType =ReadWORD(dn%)

		'Wenn ungltiges BMP Format dann mit Fehlerwert abbrechen.
		'---------------------------------------------------------
		IF BFH.bfType <>&H4D42 then
			ErrorCode%=2
	    	close dn%
		else

			'Restlichen BitMapFileHeader einlesen.
			'-------------------------------------
			BFH.bfSize   	=ReadDWORD(dn%)
			BFH.bfReserved1 =ReadWORD (dn%)
			BFH.bfReserved2 =ReadWORD (dn%)
			BFH.bfOffBits   =ReadDWORD(dn%)

			'Den BitMapInfoHeader einlesen.
			'------------------------------
			BIH.biSize      =ReadDWORD(dn%)
			BIH.biWidth     =ReadDWORD(dn%)
			BIH.biHeight    =ReadDWORD(dn%)
			BIH.biPlanes    =ReadWORD (dn%)
			BIH.biBitCount  =ReadWORD (dn%)
	    	IF BIH.biBitCount <>&h08 THEN
				ErrorCode%=3
				close dn%
	    	else
				'Es werden keine Komprimierten DIB's untersttzt
				BIH.biCompression       =ReadDWORD(dn%)
				IF BIH.biCompression THEN
					ErrorCode%=4
		    		close dn%
				else
					BIH.biSizeImage     =ReadDWORD(dn%)
					BIH.biXPelsPerMeter =ReadDWORD(dn%)
					BIH.biYPelsPerMeter =ReadDWORD(dn%)

					BIH.biClrUsed       =ReadDWORD(dn%)
					BIH.biClrImportant  =ReadDWORD(dn%)
					close dn%
				END IF 'Compression
	    	END IF 'BitCount
		END IF 'BitmapFileType
    END IF 'file not found

    IF ErrorCode% then
		GetDIBHeader%=0
		ErrorFlag%=ErrorCode%
    else
		GetDIBHeader%=&hFFFF
    END IF

END FUNCTION

'-----------------------------------------------
'Alle Informationen zur aktuellen DIB anzeigen.
'-----------------------------------------------
SUB ShowDIBHeader() public

    dim info as local string
    dim kennung as local string

	Info$="BitMapFileHeader"+chr$(10)
    Kennung$=chr$(int(BFH.bfType MOD 256))+chr$(int(BFH.bfType/256))

    Info$=Info$+"bfType		: "+Kennung$                                           +chr$(10)
    Info$=Info$+"bfSize		:"+str$(BFH.bfSize)                                    +chr$(10)
    Info$=Info$+"bfReserviert1	:"+str$(BFH.bfReserved1)+chr$(10)
	Info$=Info$+"bfReserviert2	:"+str$(BFH.bfReserved2)+chr$(10)
    Info$=Info$+"bfOffBits	:"+str$(BFH.bfOffBits)+chr$(10)

    Info$=Info$+chr$(10)
    Info$=Info$+"BitMapInfoHeader"+chr$(10)

    Info$=Info$+"biSize		:"+str$(BIH.biSize)                                    +chr$(10)
    Info$=Info$+"biWidth	    	:"+str$(BIH.biWidth)+chr$(10)
    Info$=Info$+"biHeight	    	:"+str$(BIH.biHeight)+chr$(10)
    Info$=Info$+"biPlanes	    	:"+str$(BIH.biPlanes)+chr$(10)
    Info$=Info$+"biBitCount	:"+str$(BIH.biBitCount)+chr$(10)
    Info$=Info$+"biCompression	:"+str$(BIH.biCompression)+chr$(10)
    Info$=Info$+chr$(10)

	Info$=Info$+"biSizeImage	:"+str$(BIH.biSizeImage)+chr$(10)
	Info$=Info$+"biXpelsPerMeter	:"+str$(BIH.biXPelsPerMeter)+chr$(10)
    Info$=Info$+"biYPelsPerMeter	:"+str$(BIH.biYPelsPerMeter)+chr$(10)
    Info$=Info$+chr$(10)

    Info$=Info$+"biClrUsed	:"+str$(BIH.biClrUsed)+chr$(10)
    Info$=Info$+"biClrImportant	:"+str$(BIH.biClrImportant)+chr$(10)

    print Info$

END SUB

SUB LoadDIB (	byval dname as string,_
				byval zSEG as word,_
                byval zOFF as word,_
                byval qstart as integer,_
                byval zstart as integer,_
                byval zAnz as integer) public

    dim dn 			as local integer
    dim Zeile(319) 	as local byte
    dim ZeileSEG	as local word
    dim ZeileOFF 	as local word
    dim x			as local integer
    dim y			as local integer
    dim i			as local integer

    IF BIH.biBitCount<>&h08 THEN EXIT SUB
    IF BIH.biWidth   <  320 THEN EXIT SUB
    IF BIH.biHeight  <  200 THEN EXIT SUB
    IF BIH.biCompression    THEN EXIT SUB

    ZeileSEG??=varseg(Zeile?(0))
    ZeileOFF??=varptr(Zeile?(0))

    dn%=FreeFile

    OPEN dname$ FOR BINARY AS dn%

    'Dateizeiger auf die Bilddaten setzen
    Seek dn,BFH.bfOffBits
    for y%=199 to 0 step -1
		for x%=0 to 319
			Zeile?(x%)=ReadBYTE(dn%)
		next
		IF y%<=qstart%+zAnz% and y%>=qstart% then

			gCopyUp ZeileSEG??,ZeileOFF??,zSEG??,zOFF??,0,0, 0,zStart%+zAnz%-i,320,1
			incr i%
		END IF
    next
    close dn%

END SUB

SUB LoadDIBColorPAL (	byval dname as string) public

    dim dn 		as local integer
    dim cAnz 	as local integer
    dim z		as local integer
    dim r		as local byte
    dim g		as local byte
    dim b		as local byte
    dim dummy	as local byte

    dn%=FreeFile

    ON ERROR RESUME NEXT
    OPEN dname$ FOR INPUT AS dn%
    IF ERR=53 THEN
		close dn%
		EXIT SUB
    else
		close dn%
		IF BIH.biClrUsed and (BIH.biClrUsed < 2^BIH.biBitCount-1) THEN
        	cAnz%=BIH.biClrUsed
		else
			cAnz%=2^BIH.biBitCount-1
		END IF

		dn%=FreeFile

		OPEN dname$ FOR BINARY AS dn%
		Seek dn%,54

        def seg=rgbSEG??

		For z%=0 to cAnz%

			r?=ReadBYTE(dn%)
	    	shift right r?,2
            poke rgbOFF??+z%*3+0,r?

	    	g?=ReadBYTE(dn%)
	    	shift right g?,2
            poke rgbOFF??+z%*3+1,g?

	    	b?=ReadBYTE(dn%)
	    	shift right b?,2
            poke rgbOFF??+z%*3+2,b?

	    	dummy?=ReadBYTE(dn%)
		next

        def seg

	close dn%
    END IF

END SUB

'##########################
'# ---------------------- #
'#  Soundblaster Section  #
'# ---------------------- #
'##########################

SUB PlayDSP(byval DspAdr as word,byval DSPIRQ as word,byval qSEG as word,byval qOFF as word,byval qLEN as word,byval qSPEED as word) public


		!jmp    near dspplay    ;Datenbereich im Codesegment

oldvecoff:
		!dw     &h0000
oldvecseg:
		!dw     &h0000
dmasreg:
		!db     &h00
oldint:
		!dw     &h0000
oldmask:
		!db     &h00
mDSP:
		!dw     &h0000
mIRQ:
		!dw     &h0000
mDMA:
		!dw     &h0000
mSPEED:
		!dw     &h0000
playlen:
		!dw     &h0000


dspplay:
		!push   bp
		!push   ds
		!push   es

		!CLI
		!mov    AX,DSPAdr??
		!mov    CS:mDSP,AX              ;Portadresse merken

		!mov    AX,DSPIRQ??
		!mov    CS:mIRQ,AX              ;Hardware-IRQ merken


		!mov    AX,qSPEED??
		!mov    CS:mSPEED,AX    		;Teilerverhltnis merken

		!mov    AX,&h0000               ;Segment 0 Interrupttabelle
		!mov    ES,AX

'*------------------------------------------------------------------------*
'  Fr laufendes Hauptprogramm aktuelle Soundausgabe signalisieren
'*------------------------------------------------------------------------*
		!mov    AX,&hffff
		!mov    ES:[&h04f0],AX  		;-1 = busy  0 = ready

		!mov    BX,DSPIRQ??             ;Interrupt-Nummer
		!mov    CL,BL           		;in CL merken
		!shl    BX,1            		;Interrupt Nr. * 4
		!shl    BX,1
		!cmp    BX,&h20         		;Interrupt >=8 (4*8=&h20)
		!jnc    VectorTabelle2  		;Wert fr Tabelle 2 berechnen

		!add    BX,&H20                 ;Offset Tabelle 1 adieren

		!jmp near OffsetSpeichern
VectorTabelle2:
		!add    BX,&H1a0                ;Offset Tabelle 2 adieren

OffsetSpeichern:
		!mov    CS:oldint,BX

		!mov    AX,ES:[BX]              ;Offset der IRQ-Routine holen
		!mov    CS:oldvecoff,AX 		;und merken
		!mov    AX,ES:[BX+2]    		;Segment der IRQ-Routine
		!mov    CS:oldvecseg,AX 		;und merken


		!lea    AX,CS:interruptneu      ;den Offset holen

		!mov    ES:[BX],AX              ;und eintragen
		!mov    AX,CS                   ;Segment holen
		!mov    ES:[BX+2],AX            ;und eintragen


		!cmp    CL,&h08                 ;IRQ Nr. > 7
		!jnc    Controller2play

		!mov    BL,1            		;IRQ-Nr. verschieben zB. Nr. 5
		!shl    BL,CL           		;2^5=&b00100000 =  32 &h20
		!mov    CS:oldmask,BL   		;Aktive IRQ des Controller 1 merken
		!not    bl              		;   =&b11011111 = 223 &hdf
		!in     al,&h21     			;Interruptmaske vom Controller 1
		!and    al,bl                   ;IRQ Bit lschen (aktivieren)
		!out    &h21,al                 ;und dem Controller 1 miteilen
		!jmp near speakerplayon

Controller2play:
		!sub    CL,8
		!mov    BL,1
		!shl    BL,CL
		!mov    CS:oldmask,BL   		;Aktive IRQ des Controller 2 merken
		!not    BL
		!in     AL,&ha1                 ;Interruptmaske von Controller 2
		!and    AL,BL                   ;IRQ Bit lschen (aktivieren)
		!out    &ha1,AL                 ;und dem Controller 2 mitteilen
speakerplayon:
		!STI
		!mov    DX,DSPADR??     		;Portadresse von Parameter
		!mov    AX,&hd1         		;DSP Befehl Speaker on
		!call near dspwrite

		!mov    AX,&h40                 ;DSP Befehl fr SampelFreq
		!call near dspwrite
        !mov    AX,qSPEED??     		;Teilerverhltnis von Parameter
		!call near dspwrite

'*------------------------------------------------------------------------*
'  24 Bit Adresse fr das Seitenregister DMA-Controller berechnen
'*------------------------------------------------------------------------*

		!mov    DX,qSEG??               ;Segment von Parameter
		!mov    BX,DX
		!mov    CL,&h04                 ;* 16 \ 16
		!shr    DH,CL
		!shl    BX,CL
		!add    BX,qOFF??               ;Offset von Parameter
		!jnc    seitentest
		!inc    DH              		;Adressbertrag bercksichtigen

'*------------------------------------------------------------------------*
'  Ragt Sample ber eine 64K Seite hinaus wenn ja Abspiellnge korigieren
'*------------------------------------------------------------------------*

seitentest:
		!mov    CX,&hffff
		!sub    CX,BX                   ;64k - Adressoffset
		!cmp    CX,qLEN??               ;Blocklnge von Parameter
		!jc     dmaset1
		!mov    CX,qLEN??

'*------------------------------------------------------------------------*
'  DMA-Modus (Ram to DSP),Startadresse(lo,hi) und Blocklnge(lo,hi)
'*------------------------------------------------------------------------*

dmaset1:
		!mov    CS:dmasreg,DH   		;Ersatzbyte fr Neuinterrupt merken
		!mov    AL,&h05
		!out    &h0a,AL                 ;DMA Kanal 1 anhalten
		!mov    AL,&h49
		!out    &h0b,AL                 ;DMA-Modus Transfer RAM to DSP
		!out    &h0c,AL                 ;Irgend etwas fr FlipFlop (lo,hi)

		!mov    AL,BL                   ;BX = Adresse    (lo,hi)
        !out    &h02,AL
		!mov    AL,BH
		!out    &h02,AL

		!mov    AL,CL                   ;CX = Blocklnge (lo,hi)
		!out    &h03,AL
		!mov    AL,CH
		!out    &h03,AL


		!mov    AL,DH                   ;Seitenregister setzen
		!out    &h83,AL

		!mov    AL,&h01         		;DMA Kanal 1 aktivieren
		!out    &h0a,AL


'*------------------------------------------------------------------------*
'  Mit dem DSPBefehl &h14 DMA-Mode 8-BIT-PCM D/A Single-Block setzen
'*------------------------------------------------------------------------*
		!mov    DX,DSPADR??             ;Portadresse von Parameter
		!mov    AX,&h14
		!call near dspwrite

		!mov    AL,CL                   ;cx = Blocklnge (lo,hi)
        !dec 	AL
		!call near dspwrite
		!mov    AL,CH
        !dec	AL
		!call near dspwrite

'*------------------------------------------------------------------------*
'  Eine positive Differenz zwishen abgespielten Block und Samplelnge,
'  ergiebt die noch auszugebende Blocklnge welche von der Interruptroutine
'  (nach beendigung des 1 Transfers) noch zu bertragen ist.
'*------------------------------------------------------------------------*

		!inc    CX                      ;Es wurde Blocklnge-1 angegeben
		!mov    AX,qLEN??
		!sub    AX,CX                   ;Differenz bilden
		!jnc    setrestblock
		!mov    AX,&hFFFF               ;Uebertrag also Blockende setzen
setrestblock:
		!mov    CS:playlen,AX   		;Restliche Blocklnge eintragen

		!STI

		!pop    es
		!pop    ds
		!pop    bp


		EXIT SUB

'*-------------------------------------------------------------------------*
' Neue Interruptroutine die nach einem DMA-Transfer vom DSP aufgerufen wird
'*-------------------------------------------------------------------------*

interruptneu:

		!CLI
		!push   ax
		!push   bx
		!push   cx
		!push   dx
		!push   ds
		!push   es



		!mov    AX,CS           		;DatenSegment = CodeSegment
		!mov    DS,AX

'*-------------------------------------------------------------------------*
' Dem DSP durch lesen von Register &h0e die Bearbeitung seines Interrupst
' signalisieren und eventuell restlichen Block (! 64k Seite !) noch ausgeben.
'*-------------------------------------------------------------------------*

		!mov    DX,CS:mDSP
		!add    DX,&h0e
		!in     AL,DX

		!mov    CX,CS:playlen   		;ist noch ein Rest zu spielen
		!cmp    CX,&hFFFF
		!je     blockfertig             ;Nein

		!mov word CS:playlen,&HFFFF 	;Sampleende makieren

'*------------------------------------------------------------------------*
'  DMA-Modus (RAM to DSP),Startadresse(lo,hi) und Blocklnge(lo,hi)
'*------------------------------------------------------------------------*

dmaset2:
		!mov    AL,&h05
		!out    &h0a,AL                 ;DMA Kanal 1 Anhalten

		!mov    AL,&h49
		!out    &h0b,AL                 ;DMA-Modus Transfer RAM to DSP
		!out    &h0c,AL                 ;Irgend etwas fr FlipFlop (lo,hi)

		!mov    AL,0                    ;0!!! weil ja neue 64k Seite
        !out 	&h02,AL
		!out    &h02,AL

		!mov    AL,CL                   ;cx = Restblocklnge (lo,hi)
		!out    &h03,AL
		!mov    AL,CH
		!out    &h03,AL

		!mov    AL,CS:dmasreg   		;gemerktes Seitenregister
		!inc    AL                      ;fr neue Seite um 1 erhhen
		!out    &h83,AL         		;und setzen.

		!mov    AL,&h01         		;DMA Kanal 1 aktivieren
		!out    &h0a,AL


'*------------------------------------------------------------------------*
'  Mit dem DSPbefehl &h14 DMA-Mode 8-BIT-PCM D/A Single-Block setzen
'*------------------------------------------------------------------------*

		!mov    DX,CS:mDSP              ;gemerkte Portadresse
        !mov    AX,&h14
		!call near dspwrite
		!mov    AL,CL           		;cx = Blocklnge (lo,hi)
		!call near dspwrite
		!mov    AL,CH
		!call near dspwrite

		!jmp    near controller 		;Interupt quitieren

'*------------------------------------------------------------------------*
'  Alten Interruptvector wieder herstellen
'*------------------------------------------------------------------------*
blockfertig:
		!mov    AX,&h0000               ;Segment der Interrupttabelle
		!mov    ES,AX

		!mov    BX,CS:oldint    		;gemerkten Interruptoffset
		!mov    AX,CS:oldvecoff
		!mov    ES:[BX],AX              ;erst Offset
		!mov    AX,CS:oldvecseg
		!mov    ES:[BX+2],AX            ;dann Segment

'*-----------------------------------------------------------------------*
'  Alten Interruptszustand wieder herstellen
'*-----------------------------------------------------------------------*
		!cmp    BX,&h1c0                ;Controller 1
		!jnc    Controller2int  		;nein Controller 2

		!mov    BL,CS:oldmask   		;gemerkter Zustand holen
		!in     AL,&h21                 ;Interruptmaskregister
		!or     AL,BL
		!out    &h21,AL                 ;wieder herstellen

		!jmp near Speakerintoff

Controller2int:
		!mov    BL,CS:oldmask
		!in     AL,&ha1
		!or     AL,BL
		!out    &ha1,AL

'*------------------------------------------------------------------------*
'  Mit dem DSPbefehl &hd3 den Lautspecher ausschalten
'*------------------------------------------------------------------------*
Speakerintoff:
		!mov    DX,CS:mDSP              ;gemerkte Portadresse
		!mov    AX,&hd3
		!call near dspwrite

'*------------------------------------------------------------------------*
'  Dem laufendem Hauptprogramm das Ende der Soundausgabe signalisieren
'*------------------------------------------------------------------------*

		!mov    ax,&h0000
		!mov    es,AX
		!mov    es:[&h04f0],ax  		;-1 = busy 0 = ready


'*------------------------------------------------------------------------*
'  Dem Controller IRQ besttigen
'*------------------------------------------------------------------------*

controller:
		!mov    AL,&h20         		;IRQ Besttigen Controller 1
		!out    &h20,AL
		!mov    CX,CS:oldint
		!cmp    CX,&h1c0                ;noch Controller 2
		!jc     intneufertig    		;nein
		!out    &ha0,AL

intneufertig:
		!STI
		!pop    es
		!pop    ds
		!pop    dx
		!pop    cx
		!pop    bx
		!pop    ax


		!iret

'----------------------------------------------
dspread:
		!push   DX

		!and    DX,&hFFF0
		!or     DX,&h0e
dspread01:
		!in     AL,DX
		!and    AL,&h80
		!jz     dspread01

		!and    DX,&hFFF0
		!or     DX,&h0a
		!in     AL,DX

		!pop    DX

		!retn


dspwrite:
				!push   AX
		!push   DX

		!and    DX,&hFFF0
		!or     DX,&h0c
		!xchg   AL,AH
dspwrite01:
		!in     AL, DX
		!and    AL, &h80
		!jnz    dspwrite01

		!xchg   AL, AH
		!out    DX, AL

		!pop    DX
		!pop    AX

		!retn
END SUB


FUNCTION IFDspBusy public as INTEGER
    dim temp as local integer
    temp%=0

    !push       ES
    !mov        ax,&h0000               ;Segment 0 fr Dos Variablen
    !mov        es,ax
    !mov        ax,es:[&h04f0]   		;&hffff = busy 0 = ready

    !mov        temp%,ax
    !pop ES

	IFDspBusy%=temp%

END FUNCTION

FUNCTION ResetDSP(byval DSPAdr AS WORD) public AS INTEGER
    dim temp as local integer
	temp%=0

	!jmp near dspreset
ticks:
	!dw     &h0000

dspreset:
	!push   DS						;Segment sichern

	!mov    ax,0                	;Segment 0 fr Dos Variablen
	!mov    es,ax               	;FALSE nicht mehr beschftigt
	!mov    word es:[&h4f0],&H0000

    !mov    al,1
	!mov    dx,DSPAdr??
	!add    dx,&H06
	!out    dx,al                   ;DSP reset FLIP

	!mov    ah,0                    ;Timer FunKtion
	!int    &h1a                    ;Ticks in DX
	!mov    ticks,dx

tickswait:
	!mov    ah,0                    ;Timer function
	!int    &h1a                    ;Ticks in DX
	!cmp    dx,ticks
	!je     tickswait               ;wiederholen bis Ticks sich erhht

	!mov    al,0
	!mov    dx,DSPAdr??
	!add    dx,&H06
	!out    dx,al                   ;DSP reset FLOP

    !mov    ah,0                    ;Timer function
	!int    &h1a                    ;Ticks in DX
	!add    dx,4                    ;(1S/18.2)*4 220 ms warten
	!mov    ticks,dx

statuswait:
	!mov    dx,DspAdr??
	!add    dx,&H0a
    !in     al,dx                   ;DSP reset status holen
	!cmp    al,&haa
	!je     resetok                 ;wenn 170=&haa dann ok

	!mov    ah,0                    ;Timer function
	!int    &h1a            		;Ticks in DX
	!cmp    dx,ticks        		;ticks < 220 ms
	!jne    statuswait

	!mov    ax,&h0000               ;DSP reset error
	!jmp    short resetende

resetok:
	!mov    ax,&hFFFF               ;-1 = OK

resetende:
	!mov    temp%,ax       			;Rckgabewert

'*------------------------------------------------------------------------*
'  Mit dem DSPbefehl &hd1 den Lautspecher einschalten
'*------------------------------------------------------------------------*

	ResetDSP%=temp%

	!pop    DS              		;Segment Adresse holen

END FUNCTION

FUNCTION GetDSPAdr(DspAdr AS WORD) public AS INTEGER
    dim adr as local word
    dim temp as local integer
    adr??=&H210
    temp%=0
	WHILE adr??<&H290

	IF ResetDSP(adr??) THEN
	    temp%=-1
		EXIT LOOP
	ELSE
	    INCR adr??,&H10
	END IF
    WEND

    DspAdr??=Adr??
    GetDSPAdr%=temp%

END FUNCTION

FUNCTION GetDSPIRQ(byval SBAdr AS WORD,SBIRQ AS WORD) public AS INTEGER
    dim temp 		as local integer
    dim wSEG 		as local word
    dim wOFF 		as local word
    dim wSPEED 		as local word
    dim wLEN 		as local word
    dim DSPIRQ 		as local word
    dim i			as local word
    dim tOFF		as local word
    dim OrgVecSEG2	as local word
    dim OrgVecOff2	as local word
    dim zz			as local word
    dim dummy		as local integer
    dim wBuffer(2510) as local byte

	wSEG??=varseg(wBuffer?(0))
	wOFF??=varptr(wBuffer?(0))
    wSPEED??=210
    wLEN??=2500
    DSPIRQ??=5
    'Als Testton eine rechteck Frequenz erzeugen
    '-------------------------------------------

    for i??=0 to wLEN??
	wBuffer?(i??)=(i?? AND &H0000)*20+117
    NEXT

    IRQS:
    data 5,7,10
    restore IRQS
    for i??=1 to 3
	READ DSPIRQ??

	'Offset in IRQ-Tabelle erechnen
	'------------------------------
	IF DSPIRQ??<8 THEN
		tOFF??=DSPIRQ??*4+&H20
	else

		tOFF??=DSPIRQ??*4+&H1C0
	END IF

	'Original Adressen zur Wiederherstellung merken
	'----------------------------------------------
	DEF SEG=0
	OrgVecOFF2??=PEEKI(tOFF??)
	OrgVecSEG2??=PEEKI(tOFF??+2)
	DEF SEG

	'Die original Interruptadresse wird von PlayDSP gendert.
	'Whrend der Tonausgabe ist IFDSPBusy = True (-1)
	'--------------------------------------------------------
	PLAYDSP SBADR??,DSPIRQ??,wSEG??,wOFF??,wLEN??,wSPEED??

	'Kurz warten damit die Interruptroutine DSPBusy auf False setzen kann
	'--------------------------------------------------------------------
	zz??=0
	warteonnotIRQbusy1:
	incr zz??

	if IFDSPBusy and zz??>0 THEN warteonnotirqbusy1


	'Wenn DSPBussy False/0 ist dann stimmt der DSPIRQ?? und die
	'original IRQ-Adressen brauchen nicht mehr restauriert werden.
	'--------------------------------------------------------------
	IF IFDSPBUSY THEN
	    dummy%=ResetDSP(SBADR??)
		temp%=0
	    DEF SEG=0
	    pokeI tOFF??,orgvecOFF2??
	    pokeI tOFF??+2,orgvecSEG2??
	    DEF SEG
	else
		temp%=-1
	    SBIRQ??=DSPIRQ??

	END IF
	IF temp% THEN EXIT FOR
   NEXT

   GetDSPIRQ%=temp%

END FUNCTION

FUNCTION SoundCard(sbadr AS WORD,sbirq AS WORD,ErrorFlag AS INTEGER) public AS INTEGER
	IF GetDSPAdr(sbadr??) THEN
		IF GetDSPIrq(sbadr??,sbirq??) THEN
			ErrorFlag%=0
		else
			ErrorFlag%=2
		end if
	else
		ErrorFlag%=1
	END IF

	IF ErrorFlag% THEN
		SoundCard%=0
	else
		SoundCard%=&hFFFF
	END IF
END FUNCTION

'##################
'# -------------- #
'#  VESA Section  #
'# -------------- #
'##################

FUNCTION CSTRfromRAM(byval qSEG as word,byval qOFF as word) public AS STRING

    dim t as local string
    dim i as local integer
    dim temp as local string

	t$=chr$(32)

    DEF SEG=qSEG??
    While ASCII(t$)<>0 and i<32000
	t$=chr$(peek(qOFF??+i))
	temp$=temp$+t$
	incr i
    WEND
    DEF SEG
    CSTRfromRAM$=EXTRACT$(temp$,chr$(0))

END FUNCTION

FUNCTION ifVESA public AS INTEGER
    dim temp as local integer
    dim tempSEG as local word
    dim tempOFF as local word
    tempSEG=VISEG
    tempOFF=VIOFF
    !push 	DS
    !push 	ES
    !push 	DI

    !mov	ah,&h4F         ;Vesa Funktion im erweitertem BIOS
    !mov    al,&h00         ;Unterfunktion 00=Abfrage der SVGA Fhigkeiten
    !mov    ES,tempSEG       ;Segment auf Datenstruktur [V]esa[I]nit
    !mov    DI,tempOFF       ;Offset
    !int    &h10            ;VGA-Bios-Interrupt
    !mov    temp%,ah    	;Statusbyte > 0 dann kein Vesa-Treiber vorhanden

    !pop DI
    !pop ES
    !pop DS

    IF temp%=0 THEN ifVESA%=&HFFFF else ifVESA%=0

END FUNCTION

FUNCTION GetVesaModeCount(VMode() as word) public AS INTEGER
    dim mode 	as local word
    dim i 		as local integer
    dim z 		as local integer

    mode=0
	DEF SEG=VI.ModeSEG
    WHILE hex$(mode)<>"FFFF"
		mode=peek(VI.ModeOFF+i)+peek(VI.ModeOFF+i+1)*256
    	incr i,2
		IF hex$(mode)<>"FFFF" THEN
	    	incr z
			VMode(z)=mode

		END IF
    WEND
    DEF SEG

    GetVesaModeCount%=z

END FUNCTION

FUNCTION GetVesaModeHeader(	byval modeNr as word) public AS INTEGER

    dim temp as local integer

    temp%=0

	!push  	DS
    !push  	ES
    !push   DI
    !push   CX

    !mov    ah,&h4F         ;Vesa Funktion im erwitertem BIOS
    !mov    al,&h01         ;Unterfunktion 01=Abfrage Modusfhigkeiten
    !mov    CX,modeNr
    !mov    ES,VMHSEG      	;Segment auf Datenstruktur VesaModeHeader
    !mov    DI,VMHOFF      	;Offset
    !int    &h10            ;VGA-Bios-Interrupt
    !mov    temp,ah         ;Statusbyte > 0 dann kein Vesa-Treiber vorhanden

    !pop 	CX
    !pop 	DI
    !pop 	ES
    !pop 	DS

IF temp=0 THEN
	VMH.WindowMoveByte = VMH.WindowMoveKB*1024
	VMH.X=VMH.CharPerX
	VMH.Y=VMH.CharPerY

	IF(VMH.ModeFlag and &H0001) THEN VMH.IFMonitor  =1 else VMH.IFMonitor  =0
	IF(VMH.ModeFlag and &H0002) THEN VMH.IFOptional =1 else VMH.IFOptional =0
	IF(VMH.ModeFlag and &H0004) THEN VMH.IFBIOSText =1 else VMH.IFBIOSText =0
	IF(VMH.ModeFlag and &H0008) THEN VMH.IFColor    =1 else VMH.IFColor    =0
	IF(VMH.ModeFlag and &H0010) THEN VMH.IFGrafik   =1 else VMH.IFGrafik   =0

	IF(VMH.Window1Flag and &H0001) THEN VMH.IFW1=1     else VMH.IFW1=0
	IF(VMH.Window1Flag and &H0002) THEN VMH.IFW1Read=1 else VMH.IFW1Read=0
	IF(VMH.Window1Flag and &H0004) THEN VMH.IFW1Write=1 else VMH.IFW1Write=0

	IF(VMH.Window2Flag and &H0001) THEN VMH.IFW2=1     else VMH.IFW2=0
	IF(VMH.Window2Flag and &H0002) THEN VMH.IFW2Read=1 else VMH.IFW2Read=0
	IF(VMH.Window2Flag and &H0004) THEN VMH.IFW2Write=1 else VMH.IFW2Write=0

	GetVesaModeHeader%=&HFFFF
else
	GetVesaModeHeader%=0
end IF

END FUNCTION

SUB ShowVesaModeHeader() public

IF VMH.IFMonitor THEN
	print "Dieser Grafikmodus wird von Ihrem Monitor untersttzt."
else
	print "Dieser Grafikmodus wird von Ihrem Monitor nicht untersttzt!"
END IF

print "Das verschiebbare Speicherfenster ist"+str$(VMH.WindowKB)+"KB gro"
print "und kann in Schritten von"+str$(VMH.WindowMoveKB)+"KB verschoben werden."

print "Die Routine zur Verschiebung befindet sich an der FAR Adresse "+HEX$(VMH.CallMoveSEG)+":"+HEX$(VMH.CallMoveOFF)+"."
IF VMH.IFOptional THEN
    print "Eine Scanzeile besteht aus"+str$(VMH.BytePerScan)+" Bytes."
    IF VMH.IFGrafik THEN
		print "Dieser Grafikmodus untersttzt die Darstellung von"+str$(VMH.CharPerX)+","+str$(VMH.CharPerY)+" Pixeln."
    else
		print "Dieser Textmodus untersttzt"+str$(VMH.CharPerX)+","+str$(VMH.CharPerY)+" Zeichen."
		IF VMH.IFBIOSText THEN
			print "Das BIOS stellt Zeichen mit einer Auflsung von"+str$(VMH.CharWidth)+","+str$(VMH.CharHeight)+"Pixeln dar."
		else
	    	print "Achtung dieser Textmodus wird nicht mit Schriften vom BIOS untersttzt."
		END IF
    END IF

    print
    print "Organisation einer Grafikseite"
    print "-------------------------------
    print "Planes           :";VMH.Planes
    print "BitPerPixel      :";VMH.BitPerPixel
    print "Blocks           :";VMH.Blocks
    print "MemoryModel      :";
    IF VMH.MemoryModel<6 and VMH.MemoryModel>=0 THEN
		print MemModel$(VMH.MemoryModel)
    else
		print "Keine Angaben vorhanden."
    END IF
    print "BlocksKB         :";VMH.BlocksKB
    print
END IF


IF VMH.IFW1  THEN
	print "Das erste Speicherfenster liegt an dem Speichersegment "+hex$(VMH.Window1SEG)
    IF VMH.IFW1Read THEN print "und untersttzt das Lesen ";
    IF VMH.IFW1Write THEN print " und das Schreiben";
    print " in dem Fenster."

END IF

IF VMH.IFW2  THEN
	print "Das zweite Speicherfenster liegt an dem Speichersegment "+hex$(VMH.Window2SEG)
    IF VMH.IFW2Read THEN print "und untersttzt das Lesen";
    IF VMH.IFW2Write THEN print " und das Schreiben";
    print " in dem Fenster."

END IF


END SUB

FUNCTION GetVesaModeNumberInArray(	byval x as integer,_
									byval y as integer,_
                                    byval BitPerPixel as integer,_
                                    byval anz as integer) public AS INTEGER
	dim temp 	as local integer
    dim i		as local integer

    temp%=0
	for i=1 to anz
    	GetVesaModeHeader vmode(i)
    	IF VMH.BitPerPixel=BitPerPixel THEN
			IF (VMH.CharPerX=x) and (VMH.CharPerY=y) THEN temp=i
		END IF
    	IF temp THEN EXIT FOR
    next

    GetVesaModeNumberInArray%=temp

END FUNCTION


FUNCTION GetVesaMode() public AS INTEGER
    dim temp as local integer

	!push	DS
    !push   BX

    !mov    ah,&h4F     ;Vesa Funktion im erweitertem BIOS
    !mov    al,&h03     ;Unterfunktion 03=lesen des Vesa-Modus
    !int    &h10        ;VGA-Bios-Interrupt
    !mov    temp,BX		;Eingestellter Mode VESA=Bit 8 &!0000000100000000

    !pop 	BX
    !pop 	DS

    GetVesaMode%=temp%

END FUNCTION

SUB MoveVesaWindow(byval Page as integer,byval WindowNr as integer) public

	!push   DS
    !push   BX
    !push   DX

    !mov    ah,&h4F         ;Vesa Funktion im erweitertem BIOS
    !mov    al,&h05         ;Unterfunktion 05=Verschieben der Fenstersegmente
    !mov    BX,WindowNr% 	;0=VMH.Window1SEG 1=VMH.Window2SEG
    !mov    DX,Page%    	;Verschiebung = &A000:0000+VMH.WindowMoveKB*Page%
    !int    &h10            ;VGA-Bios-Interrupt

    !pop 	DX
    !pop 	BX
    !pop 	DS

END SUB

SUB SetVesaFastCall(byval zSEG as word,byval zOFF as word) public
    !CLI
    !push 	DS
    !push   BX
	!LEA   	BX,VESAPOKE1
    !mov    AX,zOFF
    !mov    CS:[BX],AX
    !mov    AX,zSEG
    !mov    CS:[BX+2],AX


    'In future
	'!LEA   BX,VESAPOKE2
    '!mov   AX,zOFF
    '!mov   CS:[BX],AX
    '!mov   AX,zSEG
    '!mov   CS:[BX+2],AX

    '!LEA   BX,VESAPOKE3
    '!mov   AX,zOFF
    '!mov   CS:[BX],AX
    '!mov   AX,zSEG??
    '!mov   CS:[BX+2],AX



    !pop    BX
    !pop    DS
    !STI
END SUB


SUB SetVesaMode(byval modeNr as word) public
    dim temp as local integer

    SetVesaFastCall VMH.CallMoveSEG,VMH.CallMoveOFF

	!push 	DS
    !push 	BX

    !mov  	ah,&h4F         ;Vesa Funktion im erweitertem BIOS
    !mov  	al,&h02         ;Unterfunktion 02=Setzen eines Vesa-Modus
    !mov  	BX,modeNr
    !int 	&h10            ;VGA-Bios-Interrupt

    !pop 	BX
    !pop 	DS

END SUB



SUB MoveVesaFast(byval Page as integer,byval WindowNr as integer) public

    !push   BX
    !push   DX

    !mov    BX,WindowNr  ;0=VMH.Window1SEG 1=VMH.Window2SEG
    !mov    DX,Page      ;Verschiebung = &A000:0000+VMH.WindowMoveKB*Page%

    'Call FAR VMH.CallMoveSEG:VMH.CallMoveOFF
    !DB &H9A
VESAPOKE1:
    !DW &H0000
    !DW &H0000

    !pop DX
    !pop BX

END SUB

SUB SetVesaPixel8(	byval x   as integer,_
					byval y   as integer,_
                    byval col as byte) public

    dim adr as local long
    dim memOFF as local word

    IF x<0 or x>VMH.X or y<0 or y>VMH.Y THEN EXIT SUB

    ADR&=y*VMH.BytePerSCAN+x

    memoff??=ADR& MOD VMH.WindowMoveByte
    ADR&=ADR&\VMH.WindowMoveByte

    MoveVesaFast ADR&,0

    !CLI
	!push ES
    !push BX

    !mov AX,&ha000
    !mov ES,AX
    !mov BX,memOFF??
    !mov AL,col?
    !mov BYTE ES:[BX],AL

    !pop BX
    !pop ES
    !STI

END SUB

SUB FillVesaPoly8(	xp()      as integer,_
					yp()      as integer,_
                    byval ea  as integer,_
                    byval col as byte) public

	dim hp 		as local integer
    dim tp 		as local integer
    dim lp 		as local integer
    dim rp 		as local integer
    dim hpn 	as local integer
    dim tpn 	as local integer
    dim lpn 	as local integer
    dim rpn 	as local integer
    dim pz 		as local integer
    dim lineanz as local integer
    dim lz 		as local integer
    dim rz 		as local integer
    dim lx(768) as local integer
    dim rx(768) as local integer
    dim ly(768) as local integer
    dim yd0		as local byte
    dim np		as local integer
    dim sp  	as local integer
    dim ydif 	as local integer
    dim mp 		as local integer
    dim yt 		as local integer
    dim x 		as local integer
    dim y 		as local integer
    dim ystart	as local integer
    dim xs 		as local single
    dim xstart 	as local integer
    dim xp		as local word
    dim yp		as local word
    dim adr 	as local long
    dim l 		as local word
    dim memoff  as local word

    'Hchste und tiefste Ecke sowie linkeste und rechteste suchen
    '-------------------------------------------------------------
    hp=10000:tp=-10000
    lp=10000:rp=-10000
    for pz=0 to ea
		if yp%(pz)<hp then hpn=pz:hp=yp%(pz)
		if yp%(pz)>tp then tpn=pz:tp=yp%(pz)
		if xp%(pz)<lp then lpn=pz:lp=xp%(pz)
		if xp%(pz)>rp then rpn=pz:rp=xp%(pz)
    next

    'Wenn komplette Flche nicht auf dem Bildschirm dann Abbruch
    '-----------------------------------------------------------
    if (tp<0) or (hp>VMH.Y) or (lp>VMH.X) or (rp<0)	then EXIT SUB

    lineanz=tp-hp+1

    'linke Seite Bearbeiten
    np=hpn
    yd0=0
    vlinkeseitestart:
    sp=np
    if sp=0 then np=ea else np=sp-1

    'np hher als sp then links fertig
    if yp(np)<yp(sp) then vrechteseite

    ydif=yp(np)-yp(sp)

    'wenn horizontal dann linken x-Punkt
    '-----------------------------------
    IF ydif=0 then
        incr yd0:if yd0=ea then EXIT SUB
		if xp(sp)<xp(np) then mp=sp else mp=np
		yt=yp(mp)
		if yt<0 or yt>VMH.Y then vlsweiter1
		x=xp(mp)
		if x>VMH.X then vlsweiter1
		if x<0 then x=0
		lx(lz)=x:ly(lz)=yt


		vlsweiter1:
    ELSE
		'Steigung berechnen
		'------------------
		ystart=yp(sp)
		xs!=(xp(np)-xp(sp))/ydif
		'Schleife ber Kante von oben nach unten
		'---------------------------------------
		xstart=xp(sp)
		x=0
		for y=0 to ydif
	    	yt=ystart+y
	    	if (yt<0) or (yt>VMH.Y) then vlsweiter2
			x=xstart+y*xs!

	    	'Test auf Gltigkeit
	    	'-------------------
	    	if x>(VMH.X) then vlsweiter2
	    	if x<0 then x=0
	    	lx(lz)=x
	    	ly(lz)=yt
	    	incr lz
		vlsweiter2:
		next
		decr lz
    END IF

    goto vlinkeseitestart

    vrechteseite:

    np=hpn
    yd0=0
    vrechteseitestart:
    sp=np
    if sp=ea then np=0 else np=sp+1

    'np hher als sp dann rechte Seite fertig
    if yp(np)<yp(sp) then vrechteseitefertig

    ydif=yp(np)-yp(sp)

    'wenn horizontal dann rechten x-Punkt
    '------------------------------------
    IF ydif=0 then
        incr yd0:if yd0=ea THEN EXIT SUB
		if xp(sp)>xp(np) then mp=sp else mp=np
		yt=yp(mp)
		if (yt<0) or (yt>VMH.Y) then vrsweiter1
		x=xp(mp)
		if x<0 then vrsweiter1
		if x>VMH.X then x=VMH.X
		rx(rz)=x


	vrsweiter1:
    ELSE
		'Steigung berechnen
		'------------------
		ystart=yp(sp)
		xs!=(xp(np)-xp(sp))/ydif
		'Schleife ber Kante von oben nach unten
		'---------------------------------------
		xstart=xp(sp)

		for y=0 to ydif
	    	yt=ystart+y
	    	if (yt<0) or (yt>VMH.Y) then vrsweiter2
			x=xstart+y*xs!

	    	'Test auf Gltigkeit
	    	'-------------------
	    	if x<0 then vrsweiter2
	    	if x>VMH.X then x=VMH.X
	    	rx(rz)=x
	    	incr rz
		vrsweiter2:
		next
		decr rz
    END IF

    goto vrechteseitestart

    vrechteseitefertig:

    if rz<lz then lz=rz
    if lz<=0 then EXIT SUB
    for y=0 to lz

        ADR&=ly(y)*VMH.BytePerSCAN+lx(y)
        memoff??=ADR& MOD VMH.WindowMoveByte
        'is memOFF??+X-line>64000 Byte
        IF (memOFF??+(rx(y)-ly(y)))>64000 then
           	for x=lx(y) to rx(y)
           		SetVesaPixel8 x,ly(y),col?
            next
        else
        !CLI
      	ADR&=ADR&\VMH.WindowMoveByte
        MoveVesaFast ADR&,0

        for x=0 to rx(y)-lx(y)

			!push ES
    		!push BX

    		!mov AX,&ha000
    		!mov ES,AX
    		!mov BX,memOFF??
    		!mov AL,col?
    		!mov BYTE ES:[BX],AL

    		!pop BX
    		!pop ES
        	incr memoff??
        next
        !STI
        end if
    next
	'x=xp(tpn):y=yp(tpn)
	'if x<0 or x>VMH.X then EXIT SUB
	'if y<0 or y>VMH.Y then EXIT SUB
	'SetVesaPixel8 x,y,col?
END SUB


SUB LoadVESAPCX(byval dname as string) public
    dim dn as local integer
    dim xb as local integer
    dim yh as local integer
    dim wert as local integer
    dim x as local integer
    dim xp as local integer
    dim y as local integer
    dim Zaehler as local integer
    dim z as local integer
    dim Zeile(1024) as local byte
    dim ZeileSEG as local word
    dim ZeileOff as local word

    IF PCXH.BitPerPixel<>&h08 THEN EXIT SUB
    xb%=PCXH.xMAX-PCXH.xMIN
    yh%=PCXH.yMAX-PCXH.yMIN


    ZeileSEG=varseg(zeile(0))
    ZeileOff=varptr(zeile(0))

	dn%=FreeFile

    OPEN dname$ FOR BINARY AS dn%

	'Komprimierte Datei
	IF PCXH.Komprimierung THEN

	    'Datenzeiger auf Pixeldaten setzen
		Seek dn%,128

	    'Zeilenzhler init
		y%=0


	    While y% < (yh+1)

            if y%>VMH.Y THEN EXIT LOOP
			'Spaltenzhler init
			x%=0

			'Maximal xb+1 Pixel in eine Zeilen einlesen.
			'--------------------------------------------------
			While x%<(xb+1)
				'Wenn Bit 6 und 7 gesetzt dann RLE Tupel
				wert%=ReadBYTE?(dn%)
				if wert%>=&hc0 then
		    		'Anzahl Bit 0 - 5
					zaehler%=wert% and &h3F
		    		wert%=ReadByte?(dn%)
		    		if zaehler%=1 then
						SetVesaPixel8 x%,y%,wert%
						'Zeile?(x%)=wert%
						incr x%
		    		else
						for z%=0 to zaehler-1
			    			SetVesaPixel8 x%,y%,wert%
							'Zeile?(x%)=wert%
							incr x%
                        next
		    		end if
				else
		    		SetVesaPixel8 x%,y%,wert%
					'Zeile?(x%)=wert%
		    		incr x%
				end if
           WEND
		'For xp=0 to xb
			'SetVesaPixel8 xp,y,Zeile?(xp)
		'next
		incr y%
	    WEND

	else
	   'Datenzeiger auf Pixeldaten setzen
		Seek dn%,128

	    'Zeilenzhler init
		y%=0

	    'Maximal so viele Zeilen einlesen wie in zAnz bergeben.
	    'Jedoch nicht mehr als in der Datei vorhanden
	    '-------------------------------------------------------

	    While y%<(yh+1)
		'Spaltenzhler init
			x%=0

		'Maximal xb+1 Pixel in eine Zeilen einlesen.
		'------------------------------------------
		While x%<(xb+1)
			Zeile?(x%)=ReadBYTE?(dn%)
		    incr x%

		WEND
		For xp=0 to xb
			SetVesaPixel8 xp,y,Zeile?(xp)
		NEXT
		incr y%
	    WEND
	END IF
	close dn
END SUB

SUB SetVesaPixel15( byval x as integer,_
					byval y as integer,_
                    byval r as byte,_
                    byval g as byte,_
                    byval b as byte) public

    dim adr as local long
    dim memoff as local word

    IF x<0 or x>VMH.X or y<0 or y>VMH.Y THEN EXIT SUB
	!CLI
	!push ES
    !push BX


    ADR&=y*VMH.BytePerSCAN+x*2

    memoff??=ADR& MOD VMH.WindowMoveByte
    ADR&=ADR&\VMH.WindowMoveByte

    MoveVesaFast ADR&,0

    !mov AX,&ha000
    !mov ES,AX
    !mov DX,AX
    !mov CX,AX
    !mov BX,memOFF
    !mov AX,r?      ;color=red*1024
    !mov Cl,&h0A
    !shl AX,CL
    !mov DX,AX
    !mov AX,g?      ;+green*32
    !mov CL,5
    !shl AX,CL
    !add DX,AX
    !mov AX,b?
    !add DX,AX      ;+blue

    !mov word ES:[BX],DX


    !pop BX
    !pop ES
    !STI

END SUB


SUB VesaCopy8(  byval xq as integer,_
				byval yq as integer,_
                byval xz as integer,_
                byval yz as integer,_
                byval b  as integer,_
                byval h  as integer) public

    dim buffer(1024) as local byte
    dim bSEG 	as local word
    dim bOFF 	as local word
    dim z 		as local integer
    dim adr 	as local long
    dim memOFF 	as local word

    bSEG=varseg(buffer(0))
    bOFF=varptr(buffer(0))

	FOR z=0 to h-1

	ADR&=(yq+z)*VMH.BytePerScan+xq
		memoff=ADR& MOD VMH.WindowMoveByte
	ADR&=ADR&\VMH.WindowMoveByte

	MoveVesaFast ADR&,0

	gCopyUp &ha000,memOFF,bSEG,bOFF,0,0,0,0,b,1

	ADR&=(yz+z)*VMH.BytePerScan+xz
		memoff??=ADR& MOD VMH.WindowMoveByte
	ADR&=ADR&\VMH.WindowMoveByte

	MoveVesaFast ADR&,0

	gCopyUp bSEG,bOFF,&ha000,memOFF??,0,0,0,0,b,1
    next
END SUB

SUB VesaMaskCopy8(	byval xq  as integer,_
					byval yq  as integer,_
                    byval xz  as integer,_
                    byval yz  as integer,_
                    byval b   as integer,_
                    byval h   as integer,_
                    byval col as byte) public

    dim buffer(1024) as local byte
    dim bseg as local word
    dim boff as local word
    dim z as local integer
    dim adr as local long
    dim memoff as local word


    bSEG??=varseg(buffer?(0))
    bOFF??=varptr(buffer?(0))

	FOR z=0 to h-1

		ADR&=(yq+z)*VMH.BytePerScan+xq
		memoff??=ADR& MOD VMH.WindowMoveByte
		ADR&=ADR&\VMH.WindowMoveByte

		MoveVesaFast ADR&,0

		gCopyUp &ha000,memOFF??,bSEG??,bOFF??,0,0,0,0,b,1

		ADR&=(yz+z)*VMH.BytePerScan+xz
		memoff??=ADR& MOD VMH.WindowMoveByte
		ADR&=ADR&\VMH.WindowMoveByte

		MoveVesaFast ADR&,0

	gMaskCopy bSEG??,bOFF??,&ha000,memOFF??,0,0,0,0,b,1,0
    next
END SUB


SUB VesaCopy15( byval xq as integer,_
				byval yq as integer,_
                byval xz as integer,_
                byval yz as integer,_
                byval b  as integer,_
                byval h  as integer) public

    dim buffer(1024) as local byte
    dim bseg as local word
    dim boff as local word
    dim z as local integer
    dim adr as local long
    dim memoff as local word

    shift left b%,1  'words
    shift left xq%,1 'words


    bSEG??=varseg(buffer?(0))
    bOFF??=varptr(buffer?(0))

	FOR z%=0 to h-1

	ADR&=(yq%+z%)*VMH.BytePerScan+xq
		memoff??=ADR& MOD VMH.WindowMoveByte
	ADR&=ADR&\VMH.WindowMoveByte

	MoveVesaFast ADR&,0

	gCopyUp &ha000,memOFF,bSEG,bOFF,0,0,0,0,b%,1%

	ADR&=(yz+z)*VMH.BytePerScan+xz*2
		memOFF??=ADR& MOD VMH.WindowMoveByte
	ADR&=ADR&\VMH.WindowMoveByte

	MoveVesaFast ADR&,0

	gCopyUp bSEG??,bOFF??,&ha000,memOFF,0,0,0,0,b%,1%
    next
END SUB

'####################
'# ---------------- #
'#  Grafik Section  #
'# ---------------- #
'####################

SUB gSetVideoMode (BYVAL mode AS BYTE) public

	!mov    AL,mode?
    !mov    AH,0            ;BIOS-Funktion 0
    !int    &H10

END SUB

FUNCTION gGetVideoMode() public AS BYTE
    dim temp as local byte
	!push   ES

    !mov    AX,&H40
    !mov    ES,AX
    !mov    AX,ES:[&H49]

    !mov    temp?,Al

    !pop    ES

    gGetVideoMode?=temp?

END FUNCTION

SUB gSetColor(byval palnr AS BYTE,byval red AS BYTE,byval green AS BYTE,byval blue AS BYTE) public
	!push ds
	!mov            ah,&h10                 ; Bios-Funktion VGA
	!mov            al,&h10                 ; Unterfunktion &h10
	!mov            bx,palnr?               ; Palettennummer
	!mov            dh,red?
	!mov            ch,green?
	!mov            cl,blue?
	!int            &h10                    ; Biosaufruf
	!pop ds
end sub


SUB gSetColorPal public
    dim z as local integer
    dim r as local byte
    dim g as local byte
    dim b as local byte

    def seg=rgbSEG??
	for z%=0 to 255

    	r?=peek(rgbOff??+z%*3+0)
    	g?=peek(rgbOFF??+z%*3+1)
    	b?=peek(rgbOFF??+z%*3+2)
		gSetColor z%,r?,g?,b?
    next
    def seg
END SUB

SUB gSetRamColorPal(byval qSEG AS WORD,byval qOFF AS WORD,byval Start AS INTEGER,byval cAnz AS INTEGER) public
	!push           BX
	!push           ES

	!mov            ah,&h10         ; Bios-Funktion VGA
	!mov            al,&h12         ; Unterfunktion &h12
	!mov            BX,Start%
	!mov            CX,cAnz%
	!mov            ES,qSEG??
	!mov            DX,qOFF??
	!int            &h10            ; Biosaufruf

	!pop            ES
	!pop            BX

END SUB

SUB gLoadColorPal(	byval dname AS STRING) public

    dim dn 	as local integer
    dim z  	as local integer
    dim r   as local byte
    dim g 	as local byte
    dim b   as local byte

    dn%=FreeFile
    ON ERROR RESUME NEXT
    OPEN dname$ FOR INPUT AS dn%
    IF ERR=53 THEN
		close dn%
		EXIT SUB
    else
		close dn%
		dn%=FreeFile
		OPEN dname$ FOR BINARY AS dn%
        print "load "+dname$+" in memory"
        print "{";

        def seg=rgbSEG??
		FOR z%=0 to 255

            r?=ReadBYTE(dn%)
            poke rgbOFF??+z%*3+0,r?

			g?=ReadBYTE(dn%)
            poke rgbOFF??+z%*3+1,g?

            b?=ReadBYTE(dn%)
            poke rgbOFF??+z%*3+2,b?
            print ".";
		next
            print "}"
        def seg
		close dn%
    END IF

END SUB

SUB gFill(byval zSEG as word,byval zOFF as word,byval anz as word,byval col1 as byte,byval col2 as byte) public
    !CLI
    !push DI
    !push ES

	'Segment = PUFFER-RAM|VIDEO-RAM
	'------------------------------
	!mov            di,zSEG??
	!mov            es,di
	!mov            di,zOFF??               ; Erste Zeile
	!mov            cx,anz??
    !shr                cx,1                    ; Anzahl der WORD'S

	!mov            al,col1?                ; Fllfarbe1
	!mov            ah,col2?                ; Fllfarbe2
    !rep                stosw

    !pop ES
    !pop DI
    !STI
END SUB

SUB gSetPixel (byval zSEG as word,byval zOFF as word,byval x as word,byval y as word,byval col as byte) public

    !CLI
	'Segment = BUFFER-RAM|VIDEO-RAM
	'------------------------------
	!mov            ax,zSEG??
	!mov            es,ax

	'offset = y * 320 + x
	'--------------------
	!mov            ax,y??                  ; y in ax
	!mov            dx,320                  ; y * 320
	!mul            dx
	!add            ax,x??                  ; y * 320 + x
	!add            ax,zOFF??               ; y * 320 + x + zOFF
	!mov            bx,ax                   ; Absoluter Offset in BX
	!mov            dx,col?                 ; PixelFarbe in DX
	!mov            es:[bx],dl              ; Farbe setzen
    !STI
END SUB

FUNCTION gGetPixel (byval qSEG as word,byval qOFF as word,byval x as word,byval y as word) public AS BYTE
    dim temp as local byte


    !CLI
	'Segment = BUFFER-RAM|VIDEO-RAM
	'------------------------------
	!mov            ax,qSEG??
	!mov            es,ax

	'offset = y * 320 + x
	'--------------------
	!mov            ax,y??                  ; y in ax
	!mov            dx,320                  ; y * 320
	!mul            dx
	!add            ax,x??                  ; y * 320 + x
	!add            ax,qOFF??               ; y * 320 + x + qOFF
	!mov            bx,ax                   ; Absoluter offset in BX
	!mov            ax,es:[bx]              ; Farbe auslesen
    !mov            temp?,ax

    gGetPixel?=temp?

    !STI
END FUNCTION

SUB gLine(byval ramSEG as word,byval ramOFF as word,byval x1 as integer,byval y1 as integer,byval x2 as integer,byval y2 as integer,byval col as byte) public
	!jmp near procgline

	'Variablen im Codesegment
	ysteigung:
	!dw             &H0000
	xsteigung:
	!dw                     &H0000
	xdifferenz:
	!dw                     &H0000
	ydifferenz:
	!dw                     &H0000
	glinetest:
	!dw                     &H0000

	'Prozedurebeginn
	procgline:
    !CLI
    !push               ds                              ; Datensegment retten


	'Segment = BUFFER-RAM|VIDEO-RAM
	'------------------------------
	!mov            ax,ramseg??
	!mov            es,ax

	'offset = y1*320+x1
	'------------------
	!mov            ax,y1%                          ; y1 in ax
	!mov            dx,320                          ; y1 * 320
	!mul            dx
	!add            ax,x1%                          ; y1 * 320 + x1
	!add            ax,ramoff??             ; y1 * 320 + x1 + Screenoffset
	!mov            bx,ax                           ; Absoluter offset in BX


	!mov            dx,col?                         ; PixelFarbe in dx
	!mov  word      cs:glinetest,0          ; Testwert zurck setzen

	'Y-Differenz = y2-y1
	'-------------------
	!mov            ax,y2%                          ; y2-y1
	!sub            ax,y1%
	!jns            ypositiv                ; wenn positiv

	'Negative Y-Steigung
	'-------------------
	!mov  word      cs:ysteigung,-320       ; negative Y-Steigung
	!neg            ax                      ; ydiff=abs(ydiff)
	!mov  word  cs:ydifferenz,ax
	!jmp            xydifferenz

	'Positive Y-Steigung
	'-------------------
	ypositiv:
	!mov  word      cs:ysteigung,320        ; positive Y-Steigung
	!mov  word      cs:ydifferenz,ax        ; Y-Differenz

	'X-Differenz = x2-x1
	'-------------------
	xydifferenz:
	!mov            ax,x2%                          ; x2-x1
	!sub            ax,x1%
	!jns            xpositiv                        ; wenn positiv

	'Negative X-Steigung
	'-------------------
	!mov  word  cs:xsteigung,-1     ; negative X-Steigung
	!neg            ax                      ; xdifferenz=abs(xdifferenz)
	!mov  word      cs:xdifferenz,ax
	!jmp            xydiff

	'Positive X-Steigung
	'-------------------
	xpositiv:
	!mov  word      cs:xsteigung,1          ; positive X-Steigung
	!mov  word      cs:xdifferenz,ax

	'Schleife ber X oder Y-Differenz
	'--------------------------------
	xydiff:
	!cmp            ax,cs:ydifferenz        ; Vergleiche xdiff. u. ydiff.
	!jc             gyschleife                      ; wenn ydiff.>xdiff.


	gxschleife:
	'Schleifenzhler = xdifferenz+1
	'------------------------------
	!mov            cx,cs:xdifferenz        ; Lnge der X-Linie
	!inc            cx

	gxfor:
	!mov            es:[bx],dl                      ; Farbe poken
	!add            bx,cs:xsteigung         ; x-offset adieren
	!mov            ax,cs:glinetest         ; Prfen auf Y-Steigung
	!add            ax,cs:ydifferenz
	!mov  word      cs:glinetest,ax
	!sub            ax,cs:xdifferenz
	!jc             gxnext                  ; keine Y-Steigung
	!mov  word      cs:glinetest,ax
	!add            bx,cs:ysteigung         ; Y-offset adieren

	gxnext:
	!loop           gxfor                           ; X-Schleife ende
	!jmp            procglineend        ; Linie fertig

	gyschleife:
	'Schleifenzhler = ydiff+1
	'-------------------------
	!mov            cx,cs:ydifferenz        ; Lnge der Y-Linie
	!inc            cx

	gyfor:
	!mov            es:[bx],dl                      ; Farbe poken
	!add            bx,cs:ysteigung         ; y-offset adieren
	!mov            ax,cs:glinetest         ; Prfen auf X-Steigung
	!add            ax,cs:xdifferenz
	!mov  word      cs:glinetest,ax
	!sub            ax,ydifferenz
	!jc             gynext                  ; keine X-Steigung
	!mov  word      cs:glinetest,ax
	!add            bx,xsteigung            ; X-offset adieren

	gynext:
	!loop           gyfor                           ; Y-Schleife ende

	procglineend:
    !pop                ds                                      ; Datensegment herstellen
    !STI
END SUB

SUB gCopyUp(byval qSEG as word,byval qOFF as word,byval zSEG as word,byval zOFF as word,byval xq as integer,byval yq as integer,byval xz as integer,byval yz as integer,byval b as integer,byval h as integer) public

		!push   ds
		!push   es
		!push   si
	    !push   di
	'Quelladresse berechnen
	'----------------------
		!mov    ax,yq%              ; Y-Quellstartposition
		!mov    dx,320              ; Y-offset = y * 320
		!mul    dx
		!add    ax,xq%              ; Y-offset = y * 320 + x
		!add    ax,qOFF??
	    !mov    si,ax               ; Quelle
	'Zieladresse berechnen
	'---------------------
		!mov    ax,yz%              ; Y-Zielstartposition
		!mov    dx,320
		!mul    dx
		!add    ax,xz%
		!add    ax,zOFF??
		!mov    di,ax               ; Ziehl

		!mov    dx,zSEG??           ; Zielsegment
		!mov    es,dx               ; ES auf Ziel
		!mov    dx,qSEG??           ; Quellsegment
		!mov    ds,dx               ; DS auf Quelle

	    !mov    dx,h%               ; Anzahl der Zeilen (hhe)
	    !cld                        ; Richtungsflag lschen

gzeilenloop:
		!mov    cx,b%               ; Pixel pro Zeile (breite)
		!shr    cx,1                ; Es werden WORD'S kopiert
		!db     &h60
		!rep    movsw               ; Eine Zeile kopieren
		!db     &h61                ; Quell und Zieladressen
									' vom Stack holen und auf
		!add    si,320              ; nchste Zeile adressieren
		!add    di,320              ; Y-neu = Y-alt+320
		!dec    dx                  ; Zeilenzhler - 1
		!jnz    gzeilenloop         ; Alle Zeilen kopieren

		!pop    di
	    !pop    si
	    !pop    es
	    !pop    ds
end sub

SUB gCopyDouwn(byval qSEG as word,byval qOFF as word,byval zSEG as word,byval zOFF as word,byval xq as integer,byval yq as integer,byval xz as integer,byval yz as integer,byval b as integer,byval h as integer) public
        incr yq%,h%
        incr yz%,h%


        !CLI
		!push   ds
		!push   es
		!push   si
	    !push   di
	'Quelladresse berechnen
	'----------------------
		!mov    ax,yq%              ; Y-Quellstartposition
		!mov    dx,320              ; Y-offset = y * 320
		!mul    dx
		!add    ax,xq%              ; Y-offset = y * 320 + x
		!add    ax,qOFF??
	    !mov    si,ax               ; Quelle
	'Zieladresse berechnen
	'---------------------
		!mov    ax,yz%              ; Y-Zielstartposition
		!mov    dx,320
		!mul    dx
		!add    ax,xz%
		!add    ax,zOFF??
		!mov    di,ax               ; Ziehl

		!mov    dx,zSEG??           ; Zielsegment
		!mov    es,dx               ; ES auf Ziel
		!mov    dx,qSEG??           ; Quellsegment
		!mov    ds,dx               ; DS auf Quelle

	    !mov    dx,h%               ; Anzahl der Zeilen (hhe)

gzeilenloopd:
		!mov    cx,b%               ; Pixel pro Zeile (breite)
		!shr    cx,1                ; Es werden WORD'S kopiert
		!db     &h60
		!rep    movsw               ; Eine Zeile kopieren
		!db     &h61                ; Quell und Zieladressen
									' vom Stack holen und auf
		!sub    si,320              ; nchste Zeile adressieren
		!sub    di,320              ; Y-neu = Y-alt+320
		!dec    dx                  ; Zeilenzhler - 1
		!jnz    gzeilenloopd        ; Alle Zeilen kopieren

		!pop    di
	    !pop    si
	    !pop    es
	    !pop    ds
        !STI
END SUB

SUB gXcopy(byval qSEG as word,byval qOFF as word,byval zSEG as word,byval zOFF as word,byval xq as integer,byval yq as integer, byval xz as integer,byval yz as integer,byval xbreite as integer,byval ybreite as integer) public
    dim y as local integer

	for y%=0 to ybreite-1
	gCopyUP qSEG??,qOFF??,zSEG??,zOFF??,xq,yq+y, xz,yz-y, xbreite,1
    next

END SUB

SUB gMaskCopy(byval qseg as word,byval qoff as word,byval zseg as word,byval zoff as word,byval qx as integer,byval qy as integer,byval zx as integer,byval zy as integer,byval b as integer,byval h as integer,byval maske as byte) public
	!CLI
	!push           ds              ; DS auf Stack
	!push           di              ; DI  "     "
	!push           si              ; SI  "     "

	!mov            ax,qseg??       ; DS auf Quellsegment
	!mov            ds,ax
	!mov            ax,zseg??       ; ES auf Zielsegment
	!mov            es,ax
	!mov            di,zoff??       ; DI = Zieloffset
	!mov            si,qoff??       ; SI = Quelloffset

'Zieladresse Berechnen
'---------------------
	!mov            ax,320          ; Zeilenoffset
	!mov            bx,zy%          ; offset=zy*320
	!mul            bx
	!add            ax,zx%
	!add            di,ax           ; DI=Zieloffset+zy*320+zx

'Quelladresse Berechnen
'----------------------
	!mov            ax,320          ; Zeilenoffset
	!mov            bx,qy%          ; offset=qy*320
	!mul            bx
	!add            ax,qx%
	!add            si,ax           ; SI=Quelloffset+qy*320+qx

'Schleifenzhler fr hhe und breite
'-----------------------------------
	!mov            cx,h%           ; Anzahl der Zeilen


ForZeile:
	!push           cx              ; hoehe auf stack
	!mov            cx,b%           ; breite in cx
	!inc cx
	!push           di
	!push           si
BreiteLoop:
	!mov            al,[si]
	!cmp        	al,maske?
	!je     		NoCopy
	!mov            es:[di], al
NoCopy:
	!inc            si              ; Ein Pixel nach rechts
	!inc            di              ; Quelle und Ziel
	!loop           BreiteLoop      ; Alle Pixel einer Zeile
	!pop            si              ; Quelle =Quelle+320
	!add            si,320
	!pop            di              ; Ziel = Ziel+320
	!add            di,320          ; hhe hollen
	!pop            cx
	!loop           ForZeile        ; Alle Zeilen

	!pop            si
	!pop            di
	!pop            ds              ; Datensegment herstellen
	!STI
END SUB

SUB gFadeOut(byval zSEG as word,byval zOFF as word,byval x as integer,byval y as integer,byval b as integer,byval h as integer,byval anf as byte,byval ende as byte) public
	!CLI
	!push           DS              ; DS:[SI] = Zielpointer
	!push           SI

	!mov            DS,zSEG??
	!mov            SI,zOff??       ; SI = Zieloffset

'Zieladresse Berechnen
'---------------------
	!mov            ax,320          ; Zeilenoffset
	!mov            bx,y%           ; Offset=y*320
	!mul            bx
	!add            ax,x%
	!add            SI,ax           ; SI=Zieloffset+y*320+x

'Schleifenzhler fr hhe und breite
'-----------------------------------
	!mov            cx,h%           ; Anzahl der Zeilen
	!xor            AX,AX           ; High Byte fr Bytevergleich lschen

ForZeileFadeOut:
	!push           cx              ; hoehe auf stack
	!mov            cx,b%           ; breite in cx
	!inc 			cx
	!push           SI

BreiteLoopFadeOut:

	!mov            al,[SI]
	!cmp            AX,ende?        ;IF al=>ende? THEN NoFadeOut
	!jge    NoFadeOut
	!cmp            AX,anf?
	!jle    NoFadeOut               ;IF al<=anf? THEN NoFadeOut
	!dec            al
	!mov            [SI], al

NoFadeOut:
	!inc            SI              ; Ein Pixel nach rechts
	!loop   BreiteLoopFadeOut       ; Alle Pixel einer Zeile

	!pop            SI              ; Ziel = Ziel+320
	!add            SI,320
	!pop            cx

	!loop   ForZeileFadeOut         ; Alle Zeilen

	!pop            SI
	!pop            DS          	; Datensegment herstellen
	!STI
end sub

SUB gFadeIN(byval zSEG as word,byval zOFF as word,byval x as integer,byval y as integer,byval b as integer,byval h as integer,byval anf as byte,byval ende as byte) public
	!CLI
		!push           DS                              ; DS:[SI] = Zielpointer
		!push           SI

	!mov            DS,zSEG??
	!mov            SI,zOff??       ; SI = Zieloffset

'Zieladresse Berechnen
'---------------------
	!mov            ax,320                  ; Zeilenoffset
	!mov            bx,y%           ; Offset=y*320
	!mul            bx
	!add            ax,x%
	!add            SI,ax                   ; SI=Zieloffset+y*320+x

'Schleifenzhler fr hhe und breite
'-----------------------------------
	!mov            cx,h%                   ; Anzahl der Zeilen
	!xor            AX,AX           ; High Byte fr Bytevergleich lschen

ForZeileFadeIn:
	!push           cx                              ; hoehe auf stack
	!mov            cx,b%                   ; breite in cx
	!inc cx
	!push           SI

BreiteLoopFadeIn:

	!mov            al,[SI]
	!cmp            AX,ende?                ;IF al=>ende? THEN NoFadeIn
	!jge    NoFadeIn
	!cmp            AX,anf?
	!jle    NoFadeIn                        ;IF al<=anf? THEN NoFadeOut
	!inc            al
	!mov            [SI], al

NoFadeIn:
	!inc            SI                      ; Ein Pixel nach rechts
	!loop   BreiteLoopFadeIn        ; Alle Pixel einer Zeile

	!pop            SI                              ; Ziel = Ziel+320
	!add            SI,320
	!pop            cx

	!loop   ForZeileFadeIn          ; Alle Zeilen

		!pop            SI
		!pop            DS              ; Datensegment herstellen
	!STI
END SUB

SUB gColorRectangle(byval zSEG as word,byval zOFF as word,byval x1 as integer,byval y1 as integer,byval x2 as integer,byval y2 as integer,byval c1 as integer,byval c2 as integer,byval c3 as integer,byval c4 as integer) public
	dim ydif as local integer
	dim xdif as local integer
    dim ycd1 as local integer
    dim ycd2 as local integer
    dim x as local integer
    dim y as local integer
    dim ycs1 as local single
    dim ycs2 as local single
    dim xcd as local integer
    dim ce as local integer
    dim cs as local integer
    dim xcs as local single
    dim cc as local integer
    dim yy as local integer

    ydif=y2:if ydif<=0 THEN EXIT SUB
    xdif=x2:if xdif<=0 THEN EXIT SUB

    ycd1=c4-c1:ycs1!=ycd1/ydif

	ycd2=c3-c2:ycs2!=ycd2/ydif

	For y=y to y+ydif-1
		cs=c1+y*ycs1!
	    ce=c2+y*ycs2!

		xcd=ce-cs
		xcs!=xcd/xdif

	for x=0 to xdif-1
		cc=cs+x*xcs!
	    gSetPixel zSEG??,zOFF??,x1+x,y1+y,cc

	next
    next

END SUB

SUB gPrint(	byval tSEG as word,byval tOFF as word,_
			byval zSEG as word,byval zOFF as word,_
            byval x as integer,byval y as integer,_
            byval Text as string,_
            byval tx as integer,byval ty as integer,_
            byval zanz as integer) public

    dim anz as local integer
    dim cx as local integer
    dim cy as local integer
    dim i as local integer
    dim b as local string
    dim code as local integer
    dim xq as local integer
    dim yq as local integer
    dim xxq as local integer
    dim flag as local integer
    dim xx as local integer
    dim yy as local integer
    dim ttx as local integer
    dim tp as local integer

	anz=len(Text$)
	cx=x:cy=y

For i=1 to anz
	b$=mid$(Text$,i,1)
	code=asc(b$)-32

    if code>zanz Then code=0
    if code<=0 then code=0:cx=cx-(tx-5)

	xq=tx*code
    yq=int(xq/320)*ty
    xq= xq mod 320

    if code>0 then
	xxq=xq+tx-1
	flag=0
	for xx= 0 to tx-1
		for yy=0 to ty-1
			tp=gGetPixel(tSEG??,tOFF??,xxq-xx,yq+yy)
		if (tp>0) and (flag=0) then ttx=xx:flag=1:EXIT FOR
		next
		if flag then EXIT FOR
	next
    else
	ttx=0
    end if

	gMaskCopy tSEG??,tOFF??,zSEG??,zOFF??, xq,yq,cx,cy, tx-1,ty,0

    cx=cx+(tx-ttX):incr cx:if (cx+tx) > 320 then cx=x:incr cy,ty

next

END SUB

SUB gPrintFast(byval tSEG as word,byval tOFF as word,byval zSEG as word,_
               byval zOFF as word,byval x as integer,byval y as integer,byval Text as string,byval tx as integer,byval ty as integer,byval dx as integer,byval dy as integer,byval zanz as integer) public

    dim anz 	as local integer
    dim cx 		as local integer
    dim cy 		as local integer
    dim code 	as local integer
    dim i 		as local integer
    dim b 		as local string
    dim xq 		as local integer
    dim yq 		as local integer



	anz=len(Text$)
	cx=x:cy=y

For i=1 to anz
	b$=mid$(Text$,i,1)
	code=asc(b$)-32

    if code>zanz Then code=0
    if code<=0 then code=0:cx=cx-tx/2

	xq=tx*code
    yq=int(xq/320)*ty
    xq= xq mod 320

	gMaskCopy tSEG??,tOFF??,zSEG??,zOFF??, xq,yq,cx,cy, tx-1,ty,0

    cx=cx+tx+dx:if (cx+tx) > 320 then cx=x:incr cy,ty+dy

next

END SUB


SUB gLineRectangle(byval RamSeg as word,RamOff as word,byval x1 as integer,byval y1 as integer,byval x2 as integer,byval y2 as integer,byval col as byte) public

	GLine RamSeg??,RamOff??,x1,y1,x2,y1,col?
	GLine RamSeg??,RamOff??,x2,y1,x2,y2,col?
	GLine RamSeg??,RamOff??,x2,y2,x1,y2,col?
	GLine RamSeg??,RamOff??,x1,y2,x1,y1,col?

END SUB

SUB gFillPoly(byval zSEG as word,byval zOFF as word,xp() as integer,yp() as integer,byval ea as integer,byval col as byte) public
    dim hp 		as local integer
    dim tp 		as local integer
    dim lp 		as local integer
    dim rp 		as local integer
    dim hpn 	as local integer
    dim tpn 	as local integer
    dim lpn 	as local integer
    dim rpn 	as local integer
    dim pz 		as local integer
    dim lineanz as local integer
    dim lz 		as local integer
    dim rz 		as local integer
    dim lx(200) as local integer
    dim rx(200) as local integer
    dim ly(200) as local byte
    dim yd0		as local byte
    dim np		as local integer
    dim sp  	as local integer
    dim ydif 	as local integer
    dim mp 		as local integer
    dim yt 		as local byte
    dim x 		as local integer
    dim y 		as local integer
    dim ystart	as local integer
    dim xs 		as local single
    dim xstart 	as local integer
    dim xp		as local word
    dim yp		as local word

    'Hchste und tiefste Ecke sowie linkeste und rechteste suchen
    '-------------------------------------------------------------
    hp=10000:tp=-10000
    lp=10000:rp=-10000
    for pz=0 to ea
	if yp%(pz)<hp then hpn=pz:hp=yp%(pz)
	if yp%(pz)>tp then tpn=pz:tp=yp%(pz)
	if xp%(pz)<lp then lpn=pz:lp=xp%(pz)
	if xp%(pz)>rp then rpn=pz:rp=xp%(pz)
    next

    'Wenn komplette Flche nicht auf dem Bildschirm dann Abbruch
    '-----------------------------------------------------------
    if tp < 0 then EXIT SUB
    if hp > 199 then EXIT SUB
    if lp > 319 then EXIT SUB
    if rp < 0 then EXIT SUB


    lineanz=tp-hp+1


    yd0?=0

    'linke Seite Bearbeiten
    np=hpn

    linkeseitestart:
    sp=np
    if sp=ea then np=0 else np=sp+1

    'np hher als sp then links fertig
    if yp(np)<yp(sp) then rechteseite


    ydif=yp(np)-yp(sp)

    'wenn horizontal dann linken x-Punkt
    '-----------------------------------
    IF ydif=0 then
	incr yd0?:IF yd0?=ea THEN EXIT SUB
	if xp(sp)<xp(np) then mp=sp else mp=np
	yt?=yp(mp)
	if yt?>199 then lsweiter1
	x=xp(mp)
	if x>319 then lsweiter1
	if x<0 then x=0
	lx(lz)=x:ly?(lz)=yt?


	lsweiter1:
    ELSE
	'Steigung berechnen
	'------------------
	ystart=yp(sp)
	xs!=(xp(np)-xp(sp))/ydif
	'Schleife ber Kante von oben nach unten
	'---------------------------------------
	xstart=xp(sp)

	for y=0 to ydif
	    yt?=ystart+y
	    if yt?>199 then lsweiter2
		x=xstart+y*xs!

	    'Test auf Gltigkeit
	    '-------------------
	    if x>319 then lsweiter2
	    if x<0 then x=0
	    lx(lz)=x
	    ly?(lz)=yt?
	    incr lz
	lsweiter2:
	next
	decr lz
    END IF

    goto linkeseitestart

    rechteseite:
    yd0?=0
    np=hpn

    rechteseitestart:
    sp=np
    if sp=0 then np=ea else np=sp-1

    'np hher als sp dann rechte Seite fertig
    if yp(np)<yp(sp) then rechteseitefertig

    ydif=yp(np)-yp(sp)

    'wenn horizontal dann rechten x-Punkt
    '------------------------------------
    IF ydif=0 then
	incr yd0?:if yd0?=ea THEN EXIT SUB
	if xp(sp)>xp(np) then mp=sp else mp=np
	yt?=yp(mp)
	if yt?>199 then rsweiter1
	x=xp(mp)
	if x<0 then rsweiter1
	if x>319 then x=319
	rx(rz)=x


	rsweiter1:
    ELSE
	'Steigung berechnen
	'------------------
	ystart=yp(sp)
	xs!=(xp(np)-xp(sp))/ydif
	'Schleife ber Kante von oben nach unten
	'---------------------------------------
	xstart=xp(sp)

	for y=0 to ydif
	    yt?=ystart+y
	    if yt?>199 then rsweiter2
		x=xstart+y*xs!

	    'Test auf Gltigkeit
	    '-------------------
	    if x<0 then rsweiter2
	    if x>319 then x=319
	    rx(rz)=x
	    incr rz
	rsweiter2:
	next
	decr rz
    END IF

    goto rechteseitestart

    rechteseitefertig:

    if rz<lz then lz=rz
    if lz=0 then EXIT SUB
    for y=0 to lz

	GLine ZSEG??,ZOFF??,lx(y),ly?(y),rx(y),ly?(y),col?

    next
	xp??=xp(tpn)
    yp??=yp(tpn)
	if xp??>319 then EXIT SUB
	if yp??>199 then EXIT SUB
	gSetpixel zSEG??,zOFF??,xp??,yp??,col?
END SUB


SUB gFillColorPoly(	byval zSEG as word,byval zOFF as word,_
					xp() as integer,yp() as integer,_
                    byval ea as integer,cp() as integer) public

    dim hp 		as local integer
    dim tp 		as local integer
    dim lp 		as local integer
    dim rp 		as local integer
    dim hpn 	as local integer
    dim tpn 	as local integer
    dim lpn 	as local integer
    dim rpn 	as local integer
    dim pz 		as local integer
    dim lineanz as local integer
    dim lz 		as local integer
    dim rz 		as local integer
    dim lx(200) as local integer
    dim rx(200) as local integer
    dim ly(200) as local integer
    dim lc(200) as local integer
    dim rc(200) as local integer
    dim c		as local integer
    dim yd0		as local byte
    dim np		as local integer
    dim sp  	as local integer
    dim xdif	as local integer
    dim ydif 	as local integer
    dim cdif	as local integer
    dim xcd		as local integer
    dim mp 		as local integer
    dim yt 		as local byte
    dim x 		as local integer
    dim y 		as local integer
    dim ystart	as local integer
    dim cstart	as local integer
    dim xs 		as local single
    dim cs		as local single
    dim xcs		as local single
    dim xstart 	as local integer
    dim xp		as local word
    dim yp		as local word
    dim cc		as local integer

    'Hchste und tiefste Ecke sowie linkeste und rechteste suchen
    '-------------------------------------------------------------
    hp=10000:tp=-10000
    lp=10000:rp=-10000
    for pz=0 to ea
	if yp%(pz)<hp then hpn=pz:hp=yp%(pz)
	if yp%(pz)>tp then tpn=pz:tp=yp%(pz)
	if xp%(pz)<lp then lpn=pz:lp=xp%(pz)
	if xp%(pz)>rp then rpn=pz:rp=xp%(pz)
    next

    'Wenn komplette Flche nicht auf dem Bildschirm dann Abbruch
    '-----------------------------------------------------------
    if tp < 0 then EXIT SUB
    if hp > 199 then EXIT SUB
    if lp > 319 then EXIT SUB
    if rp < 0 then EXIT SUB


    lineanz=tp-hp+1


    'linke Seite Bearbeiten
    np=hpn

    yd0=0
    clinkeseitestart:
    sp=np
    if sp=ea then np=0 else np=sp+1

    'np hher als sp then links fertig
    if yp(np)<yp(sp) then crechteseite


    ydif=yp(np)-yp(sp)
    cdif=cp(np)-cp(sp)

    'wenn horizontal dann linken x-Punkt
    '-----------------------------------
    IF ydif=0 then
	incr yd0:if yd0=ea THEN EXIT SUB
	if xp(sp)<xp(np) then mp=sp else mp=np
	yt?=yp(mp)
	if yt?>199 then clsweiter1
	x=xp(mp)
	if x>319 then clsweiter1
	if x<0 then x=0
	lx(lz)=x
	ly(lz)=yt?
	lc(lz)=cp(mp)


	clsweiter1:
    ELSE
	'Steigung berechnen
	'------------------
	ystart=yp(sp)

	xs!=(xp(np)-xp(sp))/ydif
	cs!=(cp(np)-cp(sp))/ydif
	'Schleife ber Kante von oben nach unten
	'---------------------------------------
	xstart=xp(sp)
	cstart=cp(sp)

	for y=0 to ydif
	    yt?=ystart+y
	    if yt?>199 then clsweiter2
		x=xstart+y*xs!
	    c=cstart+y*cs!
	    'Test auf Gltigkeit
	    '-------------------
	    if x>319 then clsweiter2
	    if x<0 then x=0
	    lx(lz)=x
	    ly(lz)=yt?
	    lc(lz)=c
	    incr lz
	clsweiter2:
	next
	decr lz
    END IF

    goto clinkeseitestart

    crechteseite:

    np=hpn

    crechteseitestart:
    sp=np
    if sp=0 then np=ea else np=sp-1

    'np hher als sp dann rechte Seite fertig
    if yp(np)<yp(sp) then crechteseitefertig

    ydif=yp(np)-yp(sp)
    cdif=cp(np)-cp(sp)
    yd0=0

    'wenn horizontal dann rechten x-Punkt
    '------------------------------------
    IF ydif=0 then
	incr yd0:if yd0>ea THEN EXIT SUB
	if xp(sp)>xp(np) then mp=sp else mp=np
	yt?=yp(mp)
	if yt?>199 then crsweiter1
	x=xp(mp)
	if x<0 then crsweiter1
	if x>319 then x=319
	rx(rz)=x
	rc(rz)=cp(mp)


	crsweiter1:
    ELSE
	'Steigung berechnen
	'------------------
	ystart=yp(sp)
	cstart=cp(sp)
	xs!=(xp(np)-xp(sp))/ydif
	cs!=(cp(np)-cp(sp))/ydif

	'Schleife ber Kante von oben nach unten
	'---------------------------------------
	xstart=xp(sp)

	for y=0 to ydif
	    yt?=ystart+y
	    if yt?>199 then crsweiter2
		x=xstart+y*xs!
	    c=cstart+y*cs!
	    'Test auf Gltigkeit
	    '-------------------
	    if x<0 then crsweiter2
	    if x>319 then x=319
	    rx(rz)=x
	    rc(rz)=c
	    incr rz
	crsweiter2:
	next
	decr rz
    END IF

    goto crechteseitestart

    crechteseitefertig:

    if rz<lz then lz=rz
    if lz=0 then EXIT SUB
    for y=0 to lz
	xdif=rx(y)-lx(y)
		xcd=rc(y)-lc(y)
	if xdif=0 then
		xcs!=0
	else
		xcs!=xcd/xdif
	end if
	cstart%=lc%(y%)
	xstart%=lx%(y%)
	yp??=ly%(y%)

	if xdif%=0 then xdif%=1


	for x%=0 to xdif
		cc%=cstart%+x%*xcs!
	    gSetPixel zSEG??,zOFF??,xstart%+x%,yp??,cc%

	next

    next
END SUB

SUB gPaintTexture (byval QSEG as word,byval QOFF as word,byval ZSEG as word,byval ZOFF as word,byval xa as integer,byval ya as integer,byval pb as integer,byval lh as integer,byval rh as integer,byval texb as integer,byval texh as integer) public

    dim lhminusrh 	as local integer
    dim texh2       as local integer
    dim x			as local integer
    dim xax			as local integer
    dim ht			as local integer
    dim ht2			as local integer
    dim htt			as local integer
    dim texbxpb		as local integer
    dim y			as local integer
    dim yay			as local integer
    dim yaym		as local integer
    dim ytexhht2	as local integer

    IF pb=0 Then EXIT SUB
	lhminusrh=lh-rh
	texh2=texh\2
	for x=0 to pb

    xax=xa+x
    if xax<0 or xax>319 then NextTexXPoint
	htt=lh-lhminusrh*x/pb

    ht=htt\2


    ht2=htt

    texbxpb=texb*x/pb

    for y=0 to ht
    yaym=ya-y:if yaym<0 or yaym>199 then NextTexYPoint
    yay =ya+y:if yay <0 or yay >199 then NextTexYPoint

    'Division Error abfangen
    if ht2=0 then
    ytexhht2=y*texh
    else
    ytexhht2=y*texh\ht2
    end if

    gSetPixel ZSEG??,ZOFF??,xax,yaym,gGetPixel(QSEG??,QOFF??,texbxpb,texh2-ytexhht2)
    gSetPixel ZSEG??,ZOFF??,xax,yay ,gGetPixel(QSEG??,QOFF??,texbxpb,texh2+ytexhht2)

    NextTexYPoint:
    Next

NextTexXPoint:
Next

END SUB


SUB gMaskPaintTexture (	byval qSEG as word,_
						byval qOFF as word,_
                        byval zSEG as word,_
                        byval zOFF as word,_
                        byval xa as integer,_
                        byval ya as integer,_
                        byval pb as integer,_
                        byval lh as integer,_
                        byval rh as integer,_
                        byval texb as integer,_
                        byval texh as integer) public

    dim lhminusrh 	as local integer
    dim texh2       as local integer
    dim x			as local integer
    dim xax			as local integer
    dim ht			as local integer
    dim ht2			as local integer
    dim htt			as local integer
    dim texbxpb		as local integer
    dim y			as local integer
    dim yay			as local integer
    dim yaym		as local integer
    dim ytexhht2	as local integer
    dim p1			as local integer
    dim p2			as local integer

	IF pb=0 Then EXIT SUB


	lhminusrh=lh-rh
	texh2=texh\2
	for x=0 to pb

    xax=xa+x
    if xax<0 or xax>319 then NextMaskTexXPoint
	htt=lh-lhminusrh*x/pb

    ht=htt\2


    ht2=htt

    texbxpb=texb*x/pb

    for y=0 to ht
    yaym=ya-y:if yaym<0 or yaym>199 then NextMaskTexYPoint
    yay =ya+y:if yay <0 or yay >199 then NextMaskTexYPoint

    'Division Error abfangen
    if ht2=0 then
    ytexhht2=y*texh
    else
    ytexhht2=y*texh\ht2
    end if
    p1=gGetPixel(QSEG??,QOFF??,texbxpb,texh2-ytexhht2)
    p2=gGetPixel(QSEG??,QOFF??,texbxpb,texh2+ytexhht2)

    IF p1 and p2 THEN
	gSetPixel ZSEG??,ZOFF??,xax,yaym,p1
	gSetPixel ZSEG??,ZOFF??,xax,yay ,p2
	goto NextMaskTexYPoint
    else
	if p1 then
		gSetPixel ZSEG??,ZOFF??,xax,yaym,p1
	    goto NextMaskTexYPoint
	else
	    if p2 then gSetPixel ZSEG??,ZOFF??,xax,yay ,p2

	end if
    end if

    NextMaskTexYPoint:
    Next

NextMaskTexXPoint:
Next

END SUB

SUB gFillTexturePoly(	byval zSEG as word,_	'Segment auf Ausgabespeicher
						byval zOFF as word,_    'Offset
						xp() as integer,_       'Arrays mit
                        yp() as integer,_		'den Polygonkoordinaten
                        byval ea as integer,_   'Anzahl der Eckpunkte
                        byval yanz as word,_    'Maximale Anzahl der Y-Zeilen
                        byval qSEG as word,_    'Segment auf Texturespeicher
                        byval qOFF as word,_    'Offset
                        txp() as integer,_      'Arrays mit
                        typ() as integer) public 'den Texturekoordinaten

	dim hp 		as local integer	'hchster Punkt des Poly.
    dim tp 		as local integer    'tiefster
    dim lp 		as local integer    'linkester
    dim rp 		as local integer    'rechtester
    dim hpn 	as local integer    'Index im Array aud den hchsten Punkt
    dim tpn 	as local integer    'den tiefsten
    dim lpn 	as local integer	'den linkesten
    dim rpn 	as local integer    'den rechtesten
    dim pz 		as local integer    'Punktezhler (in den Arrays)
    dim lineanz as local integer    'Linienanzahl hchsten bis tiefsten Punkt
    dim lanz	as local integer    'Linienzhler der zu Zeichnenden Linien
    dim lz 		as local integer    'Linienzhler fr den linken Rand
    dim rz 		as local integer    '... fr den rechten Rand
    dim lx(300) as local integer    'Arrays fr die Polygonrandkoordinaten
    dim rx(300) as local integer
    dim ly(300) as local integer
    dim dif0	as local integer    'Hilfsvariable fr horizontale Polygone
    dim np		as local integer    'Nchter Punkt im Array
    dim sp  	as local integer    'Startpunkt im Array
    dim xdif	as local integer    'X-Differenz zur Bildung der Steigung
    dim ydif 	as local integer    'Y-Differenz
    dim txdif	as local integer    'Auch fr die Texture
    dim tydif	as local integer
    dim mp 		as local integer    'Gemerkter Punkt im Array
    dim yt 		as local word       'Y-Test auf Gltigkeit
    dim x 		as local integer    '
    dim y 		as local integer
    dim ystart	as local integer
    dim tystart as local integer
    dim txstart	as local integer
    dim txs		as local single     'Steigungen
    dim tys		as local single
    dim xs 		as local single
    dim xstart 	as local integer
    dim xz		as local integer
    dim yz		as local integer
    dim tx		as local integer
    dim ty		as local integer

    dim tlx(300) as local integer
    dim trx(300) as local integer
    dim tly(300) as local integer
    dim try(300) as local integer


    'Hchste und tiefste Ecke sowie linkeste und rechteste suchen
    '-------------------------------------------------------------
    hp= 10000
    tp=-10000
    lp= 10000
    rp=-10000

    for pz=0 to ea
		if yp%(pz)<hp then hpn=pz:hp=yp%(pz)
		if yp%(pz)>tp then tpn=pz:tp=yp%(pz)
		if xp%(pz)<lp then lpn=pz:lp=xp%(pz)
		if xp%(pz)>rp then rpn=pz:rp=xp%(pz)
    next

    'Wenn komplette Flche nicht auf dem Bildschirm dann Abbruch
    '-----------------------------------------------------------
    if (tp<0) or (hp>199) or (lp>319) or (rp<0) then EXIT SUB

    'linke Seite Bearbeiten
    np=hpn 								'Endpunkt = hchster Punkt im Array
    dif0=0

    linkeseitestarttex:
    sp=np                               'Startpunkt = nchster Punkt im ...
    if sp=ea then np=0 else np=sp+1     'Startpunkt = letzter Punkt im Array

    'nchster Punkt hher als Startpunkt dann linke Seite vertig
    if yp(np)<yp(sp) then rechteseitetex

    ydif=yp(np)-yp(sp)	'Y-Differenz = (Y-Endpunkt - Y-Startpunkt)

    'wenn horizontal dann linken x-Punkt
    '-----------------------------------
    IF ydif<=0 then
		incr dif0:if dif0=ea THEN EXIT SUB
		if xp(sp)<xp(np) then mp=sp else mp=np

		if yp(mp)>199 then lsweiter1tex
        if xp(mp)>319 then lsweiter1tex
		lx(lz)	=xp(mp)
		ly(lz)	=yp(mp)
		tlx(lz)	=txp(mp)
		tly(lz)	=typ(mp)

	lsweiter1tex:
    ELSE
		'Steigung berechnen
		'------------------
        xstart	= xp(sp)
		ystart	= yp(sp)
        txstart	=txp(sp)
		tystart	=typ(sp)

		xdif	=xp(np) -xstart
        txdif	=txp(np)-txstart
    	tydif	=typ(np)-tystart

		xs!=xdif/ydif
        txs!=txdif%/ydif
		tys!=tydif%/ydif

		FOR y=0 to ydif

            IF ystart>199 then lsweiter2tex
            x=xstart+y*xs!

            lx (lz)=x
	    	ly (lz)=ystart:incr ystart
	    	tlx(lz)=txstart+y*txs!
	    	tly(lz)=tystart+y*tys!
            incr lz
		lsweiter2tex:
		next
		decr lz
    END IF

    goto linkeseitestarttex

    rechteseitetex:

    np=hpn
    dif0=0
    rechteseitestarttex:
    sp=np
    if sp=0 then np=ea else np=sp-1

    'np hher als sp dann rechte Seite fertig
    if yp(np)<yp(sp) then rechteseitefertigtex

    ydif=yp(np)-yp(sp)

    'wenn horizontal dann rechten x-Punkt
    '------------------------------------
    IF ydif<=0 then
		incr dif0:if dif0=ea THEN EXIT SUB
		IF xp(sp)>xp(np) then mp=sp else mp=np

		IF yp(mp)>199 then rsweiter1tex

		IF xp(mp)<0 then rsweiter1tex
		rx(rz)=xp(mp)
        trx(rz)=txp(mp)
		try(rz)=typ(mp)

	rsweiter1tex:
    ELSE
		'Steigung berechnen
		'------------------
    	xstart	= xp(sp)
		ystart	= yp(sp)
    	txstart	=txp(sp)
		tystart	=typ(sp)

		xdif	= xp(np)-xstart
    	txdif	=txp(np)-txstart
    	tydif	=typ(np)-tystart

		xs!		=xdif /ydif
    	txs!	=txdif/ydif
		tys!	=tydif/ydif

		for y=0 to ydif
            'IF ystart>199 then rsweiter2tex
            incr ystart
			x=xstart+y*xs!
            rx (rz)=x
            trx(rz)=txstart+y*txs!
	    	try(rz)=tystart+y*tys!
            incr rz
		rsweiter2tex:
		next
		decr rz
    END IF

    goto rechteseitestarttex

    rechteseitefertigtex:


    IF lz<rz then lanz=lz else lanz=rz

    If lanz<2 THEN EXIT SUB

  	ystart=ly(yz)
  	FOR yz=0 TO lanz-1

        if ystart>199 then
        	EXIT FOR
        else
        	if ystart<0 then NextLineTex
        end if

        xstart =lx(yz)
        xdif=rx(yz)-xstart
        txstart=tlx(yz)
        tystart=tly(yz)
        txs!=(trx(yz)-txstart)/xdif
		tys!=(try(yz)-tystart)/xdif
        !CLI
        For xz=0 to xdif-1
            if xstart>319 then
        		EXIT FOR
        	else
        		if xstart<0 then NextPointTex
        	end if

	    	tx=txstart+xz*txs!
			ty=tystart+xz*tys!

			!push           AX
			!push       	BX
			!push           ES
			!push           DX

			!mov            ax,qSEG??
			!mov            es,ax

			'Offset = ty * 320 + tx
			'-----------------------
			!mov            ax,ty                   ; y in ax
			!mov            dx,320                  ; y * 320
			!mul            dx
			!add            ax,tx                   ; y * 320 + x
			!add            ax,qOFF??               ; y * 320 + x + qOFF
			!mov            bx,ax                   ; Absoluter offset in BX
			!mov            ax,es:[bx]              ; Farbe auslesen
			!push           AX                      ; Farbe auf dem Stack

			!mov            ax,zSEG??
			!mov            es,ax

			'Offset = y * 320 + x
			'---------------------
			!mov            ax,ystart          		; y in ax
            !mov 			dx,320					; y * 320
            !mul			dx
			!add            ax,xstart               ; y * 320 + x
			!add            ax,zOFF??               ; y * 320 + x + zOFF
			!mov            bx,ax                   ; Absoluter Offset in BX
			!pop        	AX              		; Farbe vom Stack
			!mov            es:[BX],AL              ; Farbe setzen

			!pop            DX
			!pop            ES
			!pop            BX
			!pop            AX

			NextPointTex:
            incr xstart
		NEXT
        !STI

	NextLineTex:
    incr ystart
    NEXT

END SUB

SUB gFillSolidPoly(	byval zSEG as word,_	'Segment auf Ausgabespeicher
					byval zOFF as word,_    'Offset
					xp() as integer,_       'Arrays mit
                    yp() as integer,_		'den Polygonkoordinaten
                    byval ea as integer,_   'Anzahl der Eckpunkte
                    byval cc as integer) public 'Fllfarbe

	dim hp 		as local integer	'hchster Punkt des Poly.
    dim tp 		as local integer    'tiefster
    dim lp 		as local integer    'linkester
    dim rp 		as local integer    'rechtester
    dim hpn 	as local integer    'Index im Array aud den hchsten Punkt
    dim tpn 	as local integer    'den tiefsten
    dim lpn 	as local integer	'den linkesten
    dim rpn 	as local integer    'den rechtesten
    dim pz 		as local integer    'Punktezhler (in den Arrays)
    dim lineanz as local integer    'Linienanzahl hchsten bis tiefsten Punkt
    dim lanz	as local integer    'Linienzhler der zu Zeichnenden Linien
    dim lz 		as local integer    'Linienzhler fr den linken Rand
    dim rz 		as local integer    '... fr den rechten Rand
    dim lx(300) as local integer    'Arrays fr die Polygonrandkoordinaten
    dim rx(300) as local integer
    dim ly(300) as local integer
    dim dif0	as local integer    'Hilfsvariable fr horizontale Polygone
    dim np		as local integer    'Nchter Punkt im Array
    dim sp  	as local integer    'Startpunkt im Array
    dim xdif	as local integer    'X-Differenz zur Bildung der Steigung
    dim ydif 	as local integer    'Y-Differenz
    dim mp 		as local integer    'Gemerkter Punkt im Array
    dim x 		as local integer    '
    dim y 		as local integer
    dim ystart	as local integer
    dim xs 		as local single
    dim xstart 	as local integer
    dim xz		as local integer
    dim yz		as local integer
    dim tx		as local integer
    dim ty		as local integer


    'Hchste und tiefste Ecke sowie linkeste und rechteste suchen
    '-------------------------------------------------------------
    hp= 10000
    tp=-10000
    lp= 10000
    rp=-10000

    for pz=0 to ea
		if yp%(pz)<hp then hpn=pz:hp=yp%(pz)
		if yp%(pz)>tp then tpn=pz:tp=yp%(pz)
		if xp%(pz)<lp then lpn=pz:lp=xp%(pz)
		if xp%(pz)>rp then rpn=pz:rp=xp%(pz)
    next

    'Wenn komplette Flche nicht auf dem Bildschirm dann Abbruch
    '-----------------------------------------------------------
    if (tp<0) or (hp>199) or (lp>319) or (rp<0) then EXIT SUB

    'linke Seite Bearbeiten
    np=hpn 								'Endpunkt = hchster Punkt im Array
    dif0=0

    linkeseitestartsolid:
    sp=np                               'Startpunkt = nchster Punkt im ...
    if sp=ea then np=0 else np=sp+1     'Startpunkt = letzter Punkt im Array

    'nchster Punkt hher als Startpunkt dann linke Seite vertig
    if yp(np)<yp(sp) then rechteseitesolid

    ydif=yp(np)-yp(sp)	'Y-Differenz = (Y-Endpunkt - Y-Startpunkt)

    'wenn horizontal dann linken x-Punkt
    '-----------------------------------
    IF ydif<=0 then
		incr dif0:if dif0=ea THEN EXIT SUB
		if xp(sp)<xp(np) then mp=sp else mp=np

		if yp(mp)>199 then lsweiter1solid
        if xp(mp)>319 then lsweiter1solid
		lx(lz)	=xp(mp)
		ly(lz)	=yp(mp)

	lsweiter1solid:
    ELSE
		'Steigung berechnen
		'------------------
        xstart	= xp(sp)
		ystart	= yp(sp)

		xdif	=xp(np) -xstart

		xs!=xdif/ydif

		FOR y=0 to ydif

            IF ystart>199 then lsweiter2solid
            x=xstart+y*xs!

            lx (lz)=x
	    	ly (lz)=ystart:incr ystart
            incr lz
		lsweiter2solid:
		next
		decr lz
    END IF

    goto linkeseitestartsolid

    rechteseitesolid:

    np=hpn
    dif0=0
    rechteseitestartsolid:
    sp=np
    if sp=0 then np=ea else np=sp-1

    'np hher als sp dann rechte Seite fertig
    if yp(np)<yp(sp) then rechteseitefertigsolid

    ydif=yp(np)-yp(sp)

    'wenn horizontal dann rechten x-Punkt
    '------------------------------------
    IF ydif<=0 then
		incr dif0:if dif0=ea THEN EXIT SUB
		IF xp(sp)>xp(np) then mp=sp else mp=np

		IF yp(mp)>199 then rsweiter1solid

		IF xp(mp)<0 then rsweiter1solid
		rx(rz)=xp(mp)

	rsweiter1solid:
    ELSE
		'Steigung berechnen
		'------------------
    	xstart	= xp(sp)
		ystart	= yp(sp)

		xdif	= xp(np)-xstart

		xs!		=xdif /ydif

		for y=0 to ydif
            'IF ystart>199 then rsweiter2solid
            incr ystart
			x=xstart+y*xs!
            rx (rz)=x
            incr rz
		rsweiter2solid:
		next
		decr rz
    END IF

    goto rechteseitestartsolid

    rechteseitefertigsolid:


    IF lz<rz then lanz=lz else lanz=rz

    If lanz<2 THEN EXIT SUB

  	ystart=ly(yz)
    !CLI
  	FOR yz=0 TO lanz-1

        if ystart>199 then
        	EXIT FOR
        else
        	if ystart<0 then NextLineSolid
        end if

        xstart =lx(yz)
        xdif=rx(yz)-xstart
        !CLI
        For xz=0 to xdif-1
            if xstart>319 then
        		EXIT FOR
        	else
        		if xstart<0 then NextPointSolid
        	end if


			!push           AX
			!push       	BX
			!push           ES
			!push           DX

			!mov            ax,zSEG??
			!mov            es,ax

			'Offset = y * 320 + x
			'---------------------
			!mov            ax,ystart          		; y in ax
            !mov 			dx,320					; y * 320
            !mul			dx
			!add            ax,xstart               ; y * 320 + x
			!add            ax,zOFF??               ; y * 320 + x + zOFF
			!mov            bx,ax                   ; Absoluter Offset in BX
			!mov        	AL,cc              		; Farbe vom Stack
			!mov            es:[BX],AL              ; Farbe setzen

			!pop            DX
			!pop            ES
			!pop            BX
			!pop            AX

			NextPointSolid:
            incr xstart
		NEXT


	NextLineSolid:
    incr ystart
    NEXT
    !STI
END SUB


FUNCTION gGetOFF(byval nr as integer,byval tx as integer,byval ty as integer) public AS WORD
    dim xq as local integer
    dim yq as local integer

	xq=tx*nr
    yq=int(xq/320)*ty
    xq= xq mod 320

    gGetOff??=yq*320+xq
END FUNCTION


SUB gNewSpot(byval zSEG as word,byval zOFF as word,byval x as integer,byval y as integer,byval col as byte) public

	!CLI
	!push DS
	!push SI

	!mov  AX,zSEG??     ;DS:[SI] Pointer
	!mov  DS,AX
	!mov  AX,zOFF??
	!mov  SI,AX

	'target-adresse
	'--------------
	!mov  ax,320  	;Zeilenoffset
	!mov  bx,y%   	;Offset=y*320
	!mul  bx
	!add  ax,x%
	!add  si,ax   	;SI=zOFF??+y*320+x
	!mov  AL,Col? 	;Farbe

	!mov [SI-321],al
	!mov [SI-320],al
	!mov [SI-319],al
	!mov [SI-1]  ,al
	!mov [SI+1]  ,al
	!mov [SI+319],al
	!mov [SI+320],al
	!mov [SI+321],al


	!pop  SI
	!pop  DS
	!STI
END SUB

SUB gImpCopy(	byval qseg as word,byval qoff as word,_
				byval zseg as word,byval zoff as word,_
                byval qx as integer,byval qy as integer,_
                byval zx as integer,byval zy as integer,_
                byval b as integer,byval h as integer) public
	!CLI
	!push           ds                              ; DS auf Stack
	!push           di              ; DI  "     "
	!push           si              ; SI  "     "

	!mov            ax,qseg??       ; DS auf Quellsegment
	!mov            ds,ax
	!mov            ax,zseg??       ; ES auf Zielsegment
	!mov            es,ax
    !mov            di,zoff??       ; DI = Zieloffset
	!mov            si,qoff??       ; SI = Quelloffset

'Zieladresse Berechnen
'---------------------
	!mov            ax,320          ; Zeilenoffset
	!mov            bx,zy%          ; offset=zy*320
	!mul            bx
	!add            ax,zx%
	!add            di,ax           ; DI=Zieloffset+zy*320+zx

'Quelladresse Berechnen
'----------------------
	!mov            ax,320          ; Zeilenoffset
	!mov            bx,qy%          ; offset=qy*320
	!mul            bx
	!add            ax,qx%
	!add            si,ax           ; SI=Quelloffset+qy*320+qx

'Schleifenzhler fr hhe und breite
'-----------------------------------
	!mov            cx,h%           ; Anzahl der Zeilen


Poliforzeile:
	!push           cx              ; hoehe auf stack
	!mov            cx,b%           ; breite in cx
	!inc cx
	!push           di
	!push           si
Polibreiteloop:
	!xor AX,AX
	!xor BX,BX
    'Quell punkte holen
	!mov al,[SI-321]    ;  Punkt 1
	!mov bl,[SI-320]
	!add AX,BX          ;+ Punkt 2
	!mov bl,[SI-319]
	!add AX,BX          ;+ Punkt 3
	!mov bl,[SI-1]
	!add AX,BX          ;+ Punkt 4
	!mov bl,[SI+1]
	!add AX,BX          ;+ Punkt 5
	!mov bl,[SI+319]
	!add AX,BX          ;+ Punkt 6
	!mov bl,[SI+320]
	!add AX,BX          ;+ Punkt 7
	!mov bl,[SI+321]
	!add AX,BX          ;+ Punkt 8

	!shr AX,1           ;Punkt (1+2+3+4+5+6+7+8)\8 = Mittelwert
	!shr AX,1
	!shr AX,1

	!or AX,AX
	!je Poliweiter1
	!dec al




Poliweiter1:
	!mov            es:[di], al     ; Mittelwert der Punkte ans Ziel

	!inc            si              ; Ein Pixel nach rechts
	!inc            di              ; Quelle und Ziel
	!loop           Polibreiteloop  ; Alle Pixel einer Zeile
	!pop            si              ; Quelle =Quelle+320
	!add            si,320
    !pop            di              ; Ziel = Ziel+320
	!add            di,320          ; hhe hollen
	!pop            cx
	!loop           Poliforzeile    ; Alle Zeilen

	!pop            si
	!pop            di
    !pop            ds              ; Datensegment herstellen
	!STI
END SUB

FUNCTION gFade(byval qSEG as word,byval qOFF as word,byval zSEG as word,byval zOFF as word,byval qx as integer,byval qy as integer,byval zx as integer,byval zy as integer,byval b as integer,byval h as integer) public AS INTEGER
    dim temp as local integer


	!CLI
	!push           ds              ; DS auf Stack
	!push           di              ; DI  "     "
	!push           si              ; SI  "     "

	!mov            ax,qseg??       ; DS auf Quellsegment
	!mov            ds,ax
	!mov            ax,zseg??       ; ES auf Zielsegment
	!mov            es,ax
	!mov            di,zoff??       ; DI = Zieloffset
	!mov            si,qoff??       ; SI = Quelloffset

'Zieladresse Berechnen
'---------------------
	!mov            ax,320          ; Zeilenoffset
	!mov            bx,zy%          ; offset=zy*320
	!mul            bx
	!add            ax,zx%
	!add            di,ax           ; DI=Zieloffset+zy*320+zx

'Quelladresse Berechnen
'----------------------
	!mov            ax,320          ; Zeilenoffset
	!mov            bx,qy%          ; offset=qy*320
	!mul            bx
	!add            ax,qx%
	!add            si,ax           ; SI=Quelloffset+qy*320+qx

'Schleifenzhler fr hhe und breite
'-----------------------------------
	!mov            cx,h%           ; Anzahl der Zeilen

ForZeileFade:
	!push           cx              ; hoehe auf stack
	!mov            cx,b%           ; breite in cx
	!inc            cx
	!push           di
	!push           si

BreiteLoopFade:
	!xor AX,AX
	!xor BX,BX

	!mov al,ds:[SI]                 ; Punkt aus Quellbild
	!mov bl,es:[DI]                 ; Punkt aus Zielbild

	!cmp AX,BX
	!je NoFade                      ; IF Quelle=Ziel THEN nchsten Punkt
	!jg FadeDouwn                   ; IF Quelle>Ziel THEN inc Ziel

FadeUp:
	!mov temp%,&HFFFF
	!dec bl                         ; IF Quelle<Ziel THEN dec Ziel
	!jmp short Weiter1Fade

FadeDouwn:
	!mov temp%,&HFFFF
	!inc bl

Weiter1Fade:
	!mov            es:[di], bl     ; Neuen Punkt im Zielbild
NoFade:
	!inc            si              ; Ein Pixel nach rechts
	!inc            di              ; Quelle und Ziel
	!loop           BreiteLoopFade  ; Alle Pixel einer Zeile
	!pop            si                              ; Quelle =Quelle+320
	!add            si,320
	!pop            di              ; Ziel = Ziel+320
	!add            di,320          ; hhe hollen
	!pop            cx
	!loop           ForZeileFade    ; Alle Zeilen

	!pop            si
	!pop            di
	!pop            ds              ; Datensegment herstellen
	!STI

	gFade%=temp%
END FUNCTION